/* menubar.c generated by valac 0.56.14, the Vala compiler
 * generated from menubar.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2011,2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Robert Ancell <robert.ancell@canonical.com>
 *          Michael Terry <michael.terry@canonical.com>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>
#include "config.h"
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <gdk/gdk.h>
#include <lightdm.h>
#include <libxapp/xapp-kbd-layout-controller.h>
#include <stdio.h>
#include <gtk/gtkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <atk/atk.h>
#include <sys/utsname.h>

#define MENU_BAR_HEIGHT 24
#define UG_SETTINGS_KEY_ONSCREEN_KEYBOARD "onscreen-keyboard"
#define UG_SETTINGS_KEY_HIGH_CONTRAST "high-contrast"
#define UG_SETTINGS_KEY_SCREEN_READER "screen-reader"
#define UG_SETTINGS_KEY_ONSCREEN_KEYBOARD_LAYOUT "onscreen-keyboard-layout"
#define UG_SETTINGS_KEY_SHOW_QUIT "show-quit"
#define UG_SETTINGS_KEY_SHOW_CLOCK "show-clock"
#define UG_SETTINGS_KEY_CLOCK_FORMAT "clock-format"
#define UG_SETTINGS_KEY_SHOW_POWER "show-power"
#define UG_SETTINGS_KEY_SHOW_KEYBOARD "show-keyboard"
#define UG_SETTINGS_KEY_SHOW_A11Y "show-a11y"
#define UG_SETTINGS_KEY_SHOW_HOSTNAME "show-hostname"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define UPOWER_TYPE_DAEMON (upower_daemon_get_type ())
#define UPOWER_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UPOWER_TYPE_DAEMON, UPowerDaemon))
#define UPOWER_IS_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UPOWER_TYPE_DAEMON))
#define UPOWER_DAEMON_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UPOWER_TYPE_DAEMON, UPowerDaemonIface))

typedef struct _UPowerDaemon UPowerDaemon;
typedef struct _UPowerDaemonIface UPowerDaemonIface;

#define UPOWER_TYPE_DAEMON_PROXY (upower_daemon_proxy_get_type ())
enum  {
	UPOWER_DAEMON_DEVICE_ADDED_SIGNAL,
	UPOWER_DAEMON_DEVICE_REMOVED_SIGNAL,
	UPOWER_DAEMON_DEVICE_CHANGED_SIGNAL,
	UPOWER_DAEMON_CHANGED_SIGNAL,
	UPOWER_DAEMON_SLEEPING_SIGNAL,
	UPOWER_DAEMON_RESUMING_SIGNAL,
	UPOWER_DAEMON_NUM_SIGNALS
};
static guint upower_daemon_signals[UPOWER_DAEMON_NUM_SIGNALS] = {0};
typedef GDBusProxy UPowerDaemonProxy;
typedef GDBusProxyClass UPowerDaemonProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define UPOWER_TYPE_DEVICE (upower_device_get_type ())
#define UPOWER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UPOWER_TYPE_DEVICE, UPowerDevice))
#define UPOWER_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UPOWER_TYPE_DEVICE))
#define UPOWER_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UPOWER_TYPE_DEVICE, UPowerDeviceIface))

typedef struct _UPowerDevice UPowerDevice;
typedef struct _UPowerDeviceIface UPowerDeviceIface;

#define UPOWER_TYPE_DEVICE_PROXY (upower_device_proxy_get_type ())
enum  {
	UPOWER_DEVICE_CHANGED_SIGNAL,
	UPOWER_DEVICE_NUM_SIGNALS
};
static guint upower_device_signals[UPOWER_DEVICE_NUM_SIGNALS] = {0};
typedef GDBusProxy UPowerDeviceProxy;
typedef GDBusProxyClass UPowerDeviceProxyClass;

#define TYPE_MENU_BAR (menu_bar_get_type ())
#define MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MENU_BAR, MenuBar))
#define MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MENU_BAR, MenuBarClass))
#define IS_MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MENU_BAR))
#define IS_MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MENU_BAR))
#define MENU_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MENU_BAR, MenuBarClass))

typedef struct _MenuBar MenuBar;
typedef struct _MenuBarClass MenuBarClass;
typedef struct _MenuBarPrivate MenuBarPrivate;

#define TYPE_BACKGROUND (background_get_type ())
#define BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND, Background))
#define BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND, BackgroundClass))
#define IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND))
#define IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND))
#define BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND, BackgroundClass))

typedef struct _Background Background;
typedef struct _BackgroundClass BackgroundClass;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
enum  {
	MENU_BAR_0_PROPERTY,
	MENU_BAR_BACKGROUND_PROPERTY,
	MENU_BAR_HIGH_CONTRAST_PROPERTY,
	MENU_BAR_KEYBOARD_WINDOW_PROPERTY,
	MENU_BAR_ACCEL_GROUP_PROPERTY,
	MENU_BAR_MAIN_WINDOW_PROPERTY,
	MENU_BAR_NUM_PROPERTIES
};
static GParamSpec* menu_bar_properties[MENU_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	BACKGROUND_DRAW_FLAGS_NONE = 1 << 0,
	BACKGROUND_DRAW_FLAGS_GRID = 1 << 1,
	BACKGROUND_DRAW_FLAGS_SPAN = 1 << 2
} BackgroundDrawFlags;

#define BACKGROUND_TYPE_DRAW_FLAGS (background_draw_flags_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MenuBarQueryUpowerDeviceData MenuBarQueryUpowerDeviceData;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef enum  {
	SHUTDOWN_DIALOG_TYPE_LOGOUT,
	SHUTDOWN_DIALOG_TYPE_SHUTDOWN,
	SHUTDOWN_DIALOG_TYPE_RESTART
} ShutdownDialogType;

#define TYPE_SHUTDOWN_DIALOG_TYPE (shutdown_dialog_type_get_type ())
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

#define TYPE_SLICK_GREETER (slick_greeter_get_type ())
#define SLICK_GREETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SLICK_GREETER, SlickGreeter))
#define SLICK_GREETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SLICK_GREETER, SlickGreeterClass))
#define IS_SLICK_GREETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SLICK_GREETER))
#define IS_SLICK_GREETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SLICK_GREETER))
#define SLICK_GREETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SLICK_GREETER, SlickGreeterClass))

typedef struct _SlickGreeter SlickGreeter;
typedef struct _SlickGreeterClass SlickGreeterClass;
typedef struct _SlickGreeterPrivate SlickGreeterPrivate;

struct _UPowerDaemonIface {
	GTypeInterface parent_iface;
	char** (*enumerate_devices) (UPowerDaemon* self, gint* result_length1, GError** error);
	gchar* (*get_daemon_version) (UPowerDaemon* self);
	gboolean (*get_on_battery) (UPowerDaemon* self);
	gboolean (*get_on_low_battery) (UPowerDaemon* self);
	gboolean (*get_lid_is_present) (UPowerDaemon* self);
	gboolean (*get_lid_is_closed) (UPowerDaemon* self);
};

struct _UPowerDeviceIface {
	GTypeInterface parent_iface;
	guint (*get_Type) (UPowerDevice* self);
	gboolean (*get_power_supply) (UPowerDevice* self);
	gboolean (*get_online) (UPowerDevice* self);
	gboolean (*get_is_present) (UPowerDevice* self);
	guint (*get_state) (UPowerDevice* self);
	gboolean (*get_is_rechargeable) (UPowerDevice* self);
	gdouble (*get_capacity) (UPowerDevice* self);
	gint64 (*get_time_to_empty) (UPowerDevice* self);
	gint64 (*get_time_to_full) (UPowerDevice* self);
	gdouble (*get_energy) (UPowerDevice* self);
	gdouble (*get_energy_empty) (UPowerDevice* self);
	gdouble (*get_energy_full) (UPowerDevice* self);
	gdouble (*get_energy_full_design) (UPowerDevice* self);
	gdouble (*get_energy_rate) (UPowerDevice* self);
	gdouble (*get_percentage) (UPowerDevice* self);
	gdouble (*get_voltage) (UPowerDevice* self);
	guint (*get_technology) (UPowerDevice* self);
	gchar* (*get_vendor) (UPowerDevice* self);
	gchar* (*get_model) (UPowerDevice* self);
	gchar* (*get_serial) (UPowerDevice* self);
};

struct _MenuBar {
	GtkMenuBar parent_instance;
	MenuBarPrivate * priv;
};

struct _MenuBarClass {
	GtkMenuBarClass parent_class;
};

struct _MenuBarPrivate {
	Background* _background;
	gboolean _high_contrast;
	GtkWindow* _keyboard_window;
	GtkAccelGroup* _accel_group;
	MainWindow* _main_window;
	gchar* default_theme_name;
	gchar* clock_format;
	GtkCheckMenuItem* high_contrast_item;
	GPid keyboard_pid;
	GPid reader_pid;
	GtkCheckMenuItem* onscreen_keyboard_item;
	GtkLabel* clock_label;
	UPowerDaemon* upowerd;
	GtkMenuItem* power_menu_item;
	GtkLabel* power_label;
	GtkImage* power_icon;
};

struct _MenuBarQueryUpowerDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MenuBar* self;
	char* dev_path;
	UPowerDevice* dev;
	UPowerDevice* _tmp0_;
	UPowerDevice* _tmp1_;
	UPowerDevice* _tmp2_;
	GError* io;
	GError* _tmp3_;
	const gchar* _tmp4_;
	guint type;
	UPowerDevice* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gboolean _tmp8_;
	UPowerDevice* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	UPowerDevice* _tmp12_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	MenuBar* self;
	GtkMenuItem* item;
	GtkLabel* label;
	XAppKbdLayoutController* xapp_controller;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	LightDMLayout* layout;
};

struct _SlickGreeter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SlickGreeterPrivate * priv;
	gboolean test_mode;
	gboolean orca_needs_kick;
};

struct _SlickGreeterClass {
	GTypeClass parent_class;
	void (*finalize) (SlickGreeter *self);
};

static gint MenuBar_private_offset;
static gpointer menu_bar_parent_class = NULL;
VALA_EXTERN SlickGreeter* slick_greeter_singleton;

VALA_EXTERN GType upower_daemon_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint upower_daemon_register_object (void* object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error);
VALA_EXTERN GType upower_daemon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UPowerDaemon, g_object_unref)
VALA_EXTERN char** upower_daemon_enumerate_devices (UPowerDaemon* self,
                                        gint* result_length1,
                                        GError** error);
VALA_EXTERN gchar* upower_daemon_get_daemon_version (UPowerDaemon* self);
VALA_EXTERN gboolean upower_daemon_get_on_battery (UPowerDaemon* self);
VALA_EXTERN gboolean upower_daemon_get_on_low_battery (UPowerDaemon* self);
VALA_EXTERN gboolean upower_daemon_get_lid_is_present (UPowerDaemon* self);
VALA_EXTERN gboolean upower_daemon_get_lid_is_closed (UPowerDaemon* self);
static GType upower_daemon_get_type_once (void);
static void upower_daemon_proxy_g_signal (GDBusProxy* proxy,
                                   const gchar* sender_name,
                                   const gchar* signal_name,
                                   GVariant* parameters);
static void _dbus_handle_upower_daemon_device_added (UPowerDaemon* self,
                                              GVariant* parameters);
static void _dbus_handle_upower_daemon_device_removed (UPowerDaemon* self,
                                                GVariant* parameters);
static void _dbus_handle_upower_daemon_device_changed (UPowerDaemon* self,
                                                GVariant* parameters);
static void _dbus_handle_upower_daemon_changed (UPowerDaemon* self,
                                         GVariant* parameters);
static void _dbus_handle_upower_daemon_sleeping (UPowerDaemon* self,
                                          GVariant* parameters);
static void _dbus_handle_upower_daemon_resuming (UPowerDaemon* self,
                                          GVariant* parameters);
static char** upower_daemon_proxy_enumerate_devices (UPowerDaemon* self,
                                              gint* result_length1,
                                              GError** error);
static gchar* upower_daemon_dbus_proxy_get_daemon_version (UPowerDaemon* self);
static gboolean upower_daemon_dbus_proxy_get_on_battery (UPowerDaemon* self);
static gboolean upower_daemon_dbus_proxy_get_on_low_battery (UPowerDaemon* self);
static gboolean upower_daemon_dbus_proxy_get_lid_is_present (UPowerDaemon* self);
static gboolean upower_daemon_dbus_proxy_get_lid_is_closed (UPowerDaemon* self);
static void upower_daemon_proxy_upower_daemon_interface_init (UPowerDaemonIface* iface);
static void _dbus_upower_daemon_enumerate_devices (UPowerDaemon* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void upower_daemon_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data);
static GVariant* upower_daemon_dbus_interface_get_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GError** error,
                                                     gpointer user_data);
static GVariant* _dbus_upower_daemon_get_daemon_version (UPowerDaemon* self);
static GVariant* _dbus_upower_daemon_get_on_battery (UPowerDaemon* self);
static GVariant* _dbus_upower_daemon_get_on_low_battery (UPowerDaemon* self);
static GVariant* _dbus_upower_daemon_get_lid_is_present (UPowerDaemon* self);
static GVariant* _dbus_upower_daemon_get_lid_is_closed (UPowerDaemon* self);
static gboolean upower_daemon_dbus_interface_set_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GVariant* value,
                                                    GError** error,
                                                    gpointer user_data);
static void _dbus_upower_daemon_device_added (GObject* _sender,
                                       const char* device,
                                       gpointer* _data);
static void _dbus_upower_daemon_device_removed (GObject* _sender,
                                         const char* device,
                                         gpointer* _data);
static void _dbus_upower_daemon_device_changed (GObject* _sender,
                                         const char* device,
                                         gpointer* _data);
static void _dbus_upower_daemon_changed (GObject* _sender,
                                  gpointer* _data);
static void _dbus_upower_daemon_sleeping (GObject* _sender,
                                   gpointer* _data);
static void _dbus_upower_daemon_resuming (GObject* _sender,
                                   gpointer* _data);
static void _upower_daemon_unregister_object (gpointer user_data);
VALA_EXTERN GType upower_device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UPowerDevice, g_object_unref)
VALA_EXTERN GType upower_device_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint upower_device_register_object (void* object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error);
VALA_EXTERN guint upower_device_get_Type (UPowerDevice* self);
VALA_EXTERN gboolean upower_device_get_power_supply (UPowerDevice* self);
VALA_EXTERN gboolean upower_device_get_online (UPowerDevice* self);
VALA_EXTERN gboolean upower_device_get_is_present (UPowerDevice* self);
VALA_EXTERN guint upower_device_get_state (UPowerDevice* self);
VALA_EXTERN gboolean upower_device_get_is_rechargeable (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_capacity (UPowerDevice* self);
VALA_EXTERN gint64 upower_device_get_time_to_empty (UPowerDevice* self);
VALA_EXTERN gint64 upower_device_get_time_to_full (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy_empty (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy_full (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy_full_design (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy_rate (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_percentage (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_voltage (UPowerDevice* self);
VALA_EXTERN guint upower_device_get_technology (UPowerDevice* self);
VALA_EXTERN gchar* upower_device_get_vendor (UPowerDevice* self);
VALA_EXTERN gchar* upower_device_get_model (UPowerDevice* self);
VALA_EXTERN gchar* upower_device_get_serial (UPowerDevice* self);
static GType upower_device_get_type_once (void);
static void upower_device_proxy_g_signal (GDBusProxy* proxy,
                                   const gchar* sender_name,
                                   const gchar* signal_name,
                                   GVariant* parameters);
static void _dbus_handle_upower_device_changed (UPowerDevice* self,
                                         GVariant* parameters);
static guint upower_device_dbus_proxy_get_Type (UPowerDevice* self);
static gboolean upower_device_dbus_proxy_get_power_supply (UPowerDevice* self);
static gboolean upower_device_dbus_proxy_get_online (UPowerDevice* self);
static gboolean upower_device_dbus_proxy_get_is_present (UPowerDevice* self);
static guint upower_device_dbus_proxy_get_state (UPowerDevice* self);
static gboolean upower_device_dbus_proxy_get_is_rechargeable (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_capacity (UPowerDevice* self);
static gint64 upower_device_dbus_proxy_get_time_to_empty (UPowerDevice* self);
static gint64 upower_device_dbus_proxy_get_time_to_full (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy_empty (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy_full (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy_full_design (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy_rate (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_percentage (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_voltage (UPowerDevice* self);
static guint upower_device_dbus_proxy_get_technology (UPowerDevice* self);
static gchar* upower_device_dbus_proxy_get_vendor (UPowerDevice* self);
static gchar* upower_device_dbus_proxy_get_model (UPowerDevice* self);
static gchar* upower_device_dbus_proxy_get_serial (UPowerDevice* self);
static void upower_device_proxy_upower_device_interface_init (UPowerDeviceIface* iface);
static void upower_device_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data);
static GVariant* upower_device_dbus_interface_get_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GError** error,
                                                     gpointer user_data);
static GVariant* _dbus_upower_device_get_Type (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_power_supply (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_online (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_is_present (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_state (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_is_rechargeable (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_capacity (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_time_to_empty (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_time_to_full (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy_empty (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy_full (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy_full_design (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy_rate (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_percentage (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_voltage (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_technology (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_vendor (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_model (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_serial (UPowerDevice* self);
static gboolean upower_device_dbus_interface_set_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GVariant* value,
                                                    GError** error,
                                                    gpointer user_data);
static void _dbus_upower_device_changed (GObject* _sender,
                                  gpointer* _data);
static void _upower_device_unregister_object (gpointer user_data);
VALA_EXTERN GType menu_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MenuBar, g_object_unref)
VALA_EXTERN GType background_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Background, g_object_unref)
VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN MenuBar* menu_bar_new (Background* bg,
                       GtkAccelGroup* ag,
                       MainWindow* mw);
VALA_EXTERN MenuBar* menu_bar_construct (GType object_type,
                             Background* bg,
                             GtkAccelGroup* ag,
                             MainWindow* mw);
static gboolean menu_bar_real_draw (GtkWidget* base,
                             cairo_t* c);
VALA_EXTERN Background* menu_bar_get_background (MenuBar* self);
VALA_EXTERN GType background_draw_flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void background_draw_full (Background* self,
                           cairo_t* c,
                           BackgroundDrawFlags flags);
VALA_EXTERN void menu_bar_set_keyboard_state (MenuBar* self);
VALA_EXTERN gboolean ug_settings_get_boolean (const gchar* key);
static void menu_bar_on_sleeping (MenuBar* self);
static void menu_bar_on_resuming (MenuBar* self);
static gboolean menu_bar_query_upower_daemon (MenuBar* self);
static void menu_bar_on_changed (MenuBar* self);
static void menu_bar_on_power_device_added (MenuBar* self,
                                     const char* device);
static void menu_bar_query_upower_device (MenuBar* self,
                                   const char* dev_path,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
static void menu_bar_query_upower_device_finish (MenuBar* self,
                                          GAsyncResult* _res_);
static void menu_bar_on_power_device_changed (MenuBar* self,
                                       const char* device);
static void menu_bar_query_upower_device_data_free (gpointer _data);
static gboolean menu_bar_query_upower_device_co (MenuBarQueryUpowerDeviceData* _data_);
static void menu_bar_update_power (MenuBar* self,
                            UPowerDevice* device);
static void menu_bar_on_power_device_removed (MenuBar* self,
                                       const char* device);
static gboolean menu_bar_update_clock (MenuBar* self);
static void menu_bar_close_pid (MenuBar* self,
                         GPid* pid);
VALA_EXTERN void menu_bar_cleanup (MenuBar* self);
static void menu_bar_real_get_preferred_height (GtkWidget* base,
                                         gint* min,
                                         gint* nat);
static GtkMenuItem* menu_bar_make_a11y_item (MenuBar* self);
static void menu_bar_keyboard_toggled_cb (MenuBar* self,
                                   GtkCheckMenuItem* item);
static void _menu_bar_keyboard_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self);
static void menu_bar_high_contrast_toggled_cb (MenuBar* self,
                                        GtkCheckMenuItem* item);
static void _menu_bar_high_contrast_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
VALA_EXTERN GtkAccelGroup* menu_bar_get_accel_group (MenuBar* self);
static void menu_bar_screen_reader_toggled_cb (MenuBar* self,
                                        GtkCheckMenuItem* item);
static void _menu_bar_screen_reader_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static GtkMenuItem* menu_bar_make_session_item (MenuBar* self);
static void ___lambda6_ (MenuBar* self);
static void ____lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void ___lambda7_ (MenuBar* self);
static void ____lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void menu_bar_shutdown_cb (MenuBar* self,
                           GtkMenuItem* item);
static void _menu_bar_shutdown_cb_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                   gpointer self);
static GtkMenuItem* menu_bar_make_keyboard_item (MenuBar* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ____lambda21_ (Block3Data* _data3_);
static void _____lambda21__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void __lambda22_ (Block2Data* _data2_);
static void ___lambda22__gdk_keymap_state_changed (GdkKeymap* _sender,
                                            gpointer self);
VALA_EXTERN MainWindow* menu_bar_get_main_window (MenuBar* self);
VALA_EXTERN GType shutdown_dialog_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void main_window_show_shutdown_dialog (MainWindow* self,
                                       ShutdownDialogType type);
VALA_EXTERN gboolean ug_settings_set_boolean (const gchar* key,
                                  gboolean value);
VALA_EXTERN GtkWindow* menu_bar_get_keyboard_window (MenuBar* self);
VALA_EXTERN gchar* ug_settings_get_string (const gchar* key);
static void menu_bar_set_keyboard_window (MenuBar* self,
                                   GtkWindow* value);
static void menu_bar_set_high_contrast (MenuBar* self,
                                 gboolean value);
VALA_EXTERN gboolean menu_bar_get_high_contrast (MenuBar* self);
VALA_EXTERN gpointer slick_greeter_ref (gpointer instance);
VALA_EXTERN void slick_greeter_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_slick_greeter (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_slick_greeter (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_slick_greeter (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_slick_greeter (const GValue* value);
VALA_EXTERN GType slick_greeter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SlickGreeter, slick_greeter_unref)
static gboolean ____lambda5_ (MenuBar* self);
static gboolean _____lambda5__gsource_func (gpointer self);
static void menu_bar_set_background (MenuBar* self,
                              Background* value);
static void menu_bar_set_accel_group (MenuBar* self,
                               GtkAccelGroup* value);
static void menu_bar_set_main_window (MenuBar* self,
                               MainWindow* value);
static GObject * menu_bar_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
static gboolean _menu_bar_update_clock_gsource_func (gpointer self);
static void _menu_bar_on_power_device_added_upower_daemon_device_added (UPowerDaemon* _sender,
                                                                 const char* device,
                                                                 gpointer self);
static void _menu_bar_on_power_device_removed_upower_daemon_device_removed (UPowerDaemon* _sender,
                                                                     const char* device,
                                                                     gpointer self);
static void _menu_bar_on_power_device_changed_upower_daemon_device_changed (UPowerDaemon* _sender,
                                                                     const char* device,
                                                                     gpointer self);
static void _menu_bar_on_changed_upower_daemon_changed (UPowerDaemon* _sender,
                                                 gpointer self);
static void _menu_bar_on_sleeping_upower_daemon_sleeping (UPowerDaemon* _sender,
                                                   gpointer self);
static void _menu_bar_on_resuming_upower_daemon_resuming (UPowerDaemon* _sender,
                                                   gpointer self);
static gboolean _menu_bar_query_upower_daemon_gsource_func (gpointer self);
static void _menu_bar_cleanup_slick_greeter_starting_session (SlickGreeter* _sender,
                                                       gpointer self);
static void menu_bar_finalize (GObject * obj);
static GType menu_bar_get_type_once (void);
static void _vala_menu_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_menu_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GDBusArgInfo _upower_daemon_dbus_arg_info_enumerate_devices_result = {-1, "result", "ao", NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_enumerate_devices_in[] = {NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_enumerate_devices_out[] = {&_upower_daemon_dbus_arg_info_enumerate_devices_result, NULL};
static const GDBusMethodInfo _upower_daemon_dbus_method_info_enumerate_devices = {-1, "EnumerateDevices", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_enumerate_devices_in), (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_enumerate_devices_out), NULL};
static const GDBusMethodInfo * const _upower_daemon_dbus_method_info[] = {&_upower_daemon_dbus_method_info_enumerate_devices, NULL};
static const GDBusArgInfo _upower_daemon_dbus_arg_info_device_added_device = {-1, "device", "o", NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_device_added[] = {&_upower_daemon_dbus_arg_info_device_added_device, NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_device_added = {-1, "DeviceAdded", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_device_added), NULL};
static const GDBusArgInfo _upower_daemon_dbus_arg_info_device_removed_device = {-1, "device", "o", NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_device_removed[] = {&_upower_daemon_dbus_arg_info_device_removed_device, NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_device_removed = {-1, "DeviceRemoved", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_device_removed), NULL};
static const GDBusArgInfo _upower_daemon_dbus_arg_info_device_changed_device = {-1, "device", "o", NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_device_changed[] = {&_upower_daemon_dbus_arg_info_device_changed_device, NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_device_changed = {-1, "DeviceChanged", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_device_changed), NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_changed[] = {NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_changed), NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_sleeping[] = {NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_sleeping = {-1, "Sleeping", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_sleeping), NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_resuming[] = {NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_resuming = {-1, "Resuming", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_resuming), NULL};
static const GDBusSignalInfo * const _upower_daemon_dbus_signal_info[] = {&_upower_daemon_dbus_signal_info_device_added, &_upower_daemon_dbus_signal_info_device_removed, &_upower_daemon_dbus_signal_info_device_changed, &_upower_daemon_dbus_signal_info_changed, &_upower_daemon_dbus_signal_info_sleeping, &_upower_daemon_dbus_signal_info_resuming, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_daemon_version = {-1, "DaemonVersion", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_on_battery = {-1, "OnBattery", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_on_low_battery = {-1, "OnLowBattery", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_lid_is_present = {-1, "LidIsPresent", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_lid_is_closed = {-1, "LidIsClosed", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _upower_daemon_dbus_property_info[] = {&_upower_daemon_dbus_property_info_daemon_version, &_upower_daemon_dbus_property_info_on_battery, &_upower_daemon_dbus_property_info_on_low_battery, &_upower_daemon_dbus_property_info_lid_is_present, &_upower_daemon_dbus_property_info_lid_is_closed, NULL};
static const GDBusInterfaceInfo _upower_daemon_dbus_interface_info = {-1, "org.freedesktop.UPower", (GDBusMethodInfo **) (&_upower_daemon_dbus_method_info), (GDBusSignalInfo **) (&_upower_daemon_dbus_signal_info), (GDBusPropertyInfo **) (&_upower_daemon_dbus_property_info), NULL};
static const GDBusInterfaceVTable _upower_daemon_dbus_interface_vtable = {upower_daemon_dbus_interface_method_call, upower_daemon_dbus_interface_get_property, upower_daemon_dbus_interface_set_property};
static const GDBusMethodInfo * const _upower_device_dbus_method_info[] = {NULL};
static const GDBusArgInfo * const _upower_device_dbus_arg_info_changed[] = {NULL};
static const GDBusSignalInfo _upower_device_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_upower_device_dbus_arg_info_changed), NULL};
static const GDBusSignalInfo * const _upower_device_dbus_signal_info[] = {&_upower_device_dbus_signal_info_changed, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_Type = {-1, "Type", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_power_supply = {-1, "PowerSupply", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_online = {-1, "Online", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_is_present = {-1, "IsPresent", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_state = {-1, "State", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_is_rechargeable = {-1, "IsRechargeable", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_capacity = {-1, "Capacity", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_time_to_empty = {-1, "TimeToEmpty", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_time_to_full = {-1, "TimeToFull", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy = {-1, "Energy", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy_empty = {-1, "EnergyEmpty", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy_full = {-1, "EnergyFull", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy_full_design = {-1, "EnergyFullDesign", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy_rate = {-1, "EnergyRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_percentage = {-1, "Percentage", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_voltage = {-1, "Voltage", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_technology = {-1, "Technology", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_vendor = {-1, "Vendor", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_model = {-1, "Model", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_serial = {-1, "Serial", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _upower_device_dbus_property_info[] = {&_upower_device_dbus_property_info_Type, &_upower_device_dbus_property_info_power_supply, &_upower_device_dbus_property_info_online, &_upower_device_dbus_property_info_is_present, &_upower_device_dbus_property_info_state, &_upower_device_dbus_property_info_is_rechargeable, &_upower_device_dbus_property_info_capacity, &_upower_device_dbus_property_info_time_to_empty, &_upower_device_dbus_property_info_time_to_full, &_upower_device_dbus_property_info_energy, &_upower_device_dbus_property_info_energy_empty, &_upower_device_dbus_property_info_energy_full, &_upower_device_dbus_property_info_energy_full_design, &_upower_device_dbus_property_info_energy_rate, &_upower_device_dbus_property_info_percentage, &_upower_device_dbus_property_info_voltage, &_upower_device_dbus_property_info_technology, &_upower_device_dbus_property_info_vendor, &_upower_device_dbus_property_info_model, &_upower_device_dbus_property_info_serial, NULL};
static const GDBusInterfaceInfo _upower_device_dbus_interface_info = {-1, "org.freedesktop.UPower.Device", (GDBusMethodInfo **) (&_upower_device_dbus_method_info), (GDBusSignalInfo **) (&_upower_device_dbus_signal_info), (GDBusPropertyInfo **) (&_upower_device_dbus_property_info), NULL};
static const GDBusInterfaceVTable _upower_device_dbus_interface_vtable = {upower_device_dbus_interface_method_call, upower_device_dbus_interface_get_property, upower_device_dbus_interface_set_property};

char**
upower_daemon_enumerate_devices (UPowerDaemon* self,
                                 gint* result_length1,
                                 GError** error)
{
	UPowerDaemonIface* _iface_;
#line 31 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 31 "menubar.vala"
	if (_iface_->enumerate_devices) {
#line 31 "menubar.vala"
		return _iface_->enumerate_devices (self, result_length1, error);
#line 736 "menubar.c"
	}
#line 31 "menubar.vala"
	return NULL;
#line 740 "menubar.c"
}

gchar*
upower_daemon_get_daemon_version (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 33 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 33 "menubar.vala"
	if (_iface_->get_daemon_version) {
#line 33 "menubar.vala"
		return _iface_->get_daemon_version (self);
#line 755 "menubar.c"
	}
#line 33 "menubar.vala"
	return NULL;
#line 759 "menubar.c"
}

gboolean
upower_daemon_get_on_battery (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 36 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 36 "menubar.vala"
	if (_iface_->get_on_battery) {
#line 36 "menubar.vala"
		return _iface_->get_on_battery (self);
#line 774 "menubar.c"
	}
#line 36 "menubar.vala"
	return FALSE;
#line 778 "menubar.c"
}

gboolean
upower_daemon_get_on_low_battery (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 37 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 37 "menubar.vala"
	if (_iface_->get_on_low_battery) {
#line 37 "menubar.vala"
		return _iface_->get_on_low_battery (self);
#line 793 "menubar.c"
	}
#line 37 "menubar.vala"
	return FALSE;
#line 797 "menubar.c"
}

gboolean
upower_daemon_get_lid_is_present (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 38 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 38 "menubar.vala"
	if (_iface_->get_lid_is_present) {
#line 38 "menubar.vala"
		return _iface_->get_lid_is_present (self);
#line 812 "menubar.c"
	}
#line 38 "menubar.vala"
	return FALSE;
#line 816 "menubar.c"
}

gboolean
upower_daemon_get_lid_is_closed (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 39 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 39 "menubar.vala"
	if (_iface_->get_lid_is_closed) {
#line 39 "menubar.vala"
		return _iface_->get_lid_is_closed (self);
#line 831 "menubar.c"
	}
#line 39 "menubar.vala"
	return FALSE;
#line 835 "menubar.c"
}

static void
upower_daemon_default_init (UPowerDaemonIface * iface,
                            gpointer iface_data)
{
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_DEVICE_ADDED_SIGNAL] = g_signal_new ("device-added", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_DEVICE_REMOVED_SIGNAL] = g_signal_new ("device-removed", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_DEVICE_CHANGED_SIGNAL] = g_signal_new ("device-changed", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_CHANGED_SIGNAL] = g_signal_new ("changed", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_SLEEPING_SIGNAL] = g_signal_new ("sleeping", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_RESUMING_SIGNAL] = g_signal_new ("resuming", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 854 "menubar.c"
}

static GType
upower_daemon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UPowerDaemonIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upower_daemon_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType upower_daemon_type_id;
	upower_daemon_type_id = g_type_register_static (G_TYPE_INTERFACE, "UPowerDaemon", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (upower_daemon_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (upower_daemon_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) upower_daemon_proxy_get_type);
	g_type_set_qdata (upower_daemon_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.UPower");
	g_type_set_qdata (upower_daemon_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_upower_daemon_dbus_interface_info));
	g_type_set_qdata (upower_daemon_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) upower_daemon_register_object);
	return upower_daemon_type_id;
}

GType
upower_daemon_get_type (void)
{
	static volatile gsize upower_daemon_type_id__once = 0;
	if (g_once_init_enter (&upower_daemon_type_id__once)) {
		GType upower_daemon_type_id;
		upower_daemon_type_id = upower_daemon_get_type_once ();
		g_once_init_leave (&upower_daemon_type_id__once, upower_daemon_type_id);
	}
	return upower_daemon_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (UPowerDaemonProxy, upower_daemon_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (UPOWER_TYPE_DAEMON, upower_daemon_proxy_upower_daemon_interface_init) )
static void
upower_daemon_proxy_class_init (UPowerDaemonProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = upower_daemon_proxy_g_signal;
}

static void
_dbus_handle_upower_daemon_device_added (UPowerDaemon* self,
                                         GVariant* parameters)
{
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp1_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	g_signal_emit_by_name (self, "device-added", device);
	_g_free0 (device);
}

static void
_dbus_handle_upower_daemon_device_removed (UPowerDaemon* self,
                                           GVariant* parameters)
{
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp2_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	g_signal_emit_by_name (self, "device-removed", device);
	_g_free0 (device);
}

static void
_dbus_handle_upower_daemon_device_changed (UPowerDaemon* self,
                                           GVariant* parameters)
{
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp3_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	g_signal_emit_by_name (self, "device-changed", device);
	_g_free0 (device);
}

static void
_dbus_handle_upower_daemon_changed (UPowerDaemon* self,
                                    GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "changed");
}

static void
_dbus_handle_upower_daemon_sleeping (UPowerDaemon* self,
                                     GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "sleeping");
}

static void
_dbus_handle_upower_daemon_resuming (UPowerDaemon* self,
                                     GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "resuming");
}

static void
upower_daemon_proxy_g_signal (GDBusProxy* proxy,
                              const gchar* sender_name,
                              const gchar* signal_name,
                              GVariant* parameters)
{
	if (strcmp (signal_name, "DeviceAdded") == 0) {
		_dbus_handle_upower_daemon_device_added ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "DeviceRemoved") == 0) {
		_dbus_handle_upower_daemon_device_removed ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "DeviceChanged") == 0) {
		_dbus_handle_upower_daemon_device_changed ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_upower_daemon_changed ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "Sleeping") == 0) {
		_dbus_handle_upower_daemon_sleeping ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "Resuming") == 0) {
		_dbus_handle_upower_daemon_resuming ((UPowerDaemon*) proxy, parameters);
	}
}

static void
upower_daemon_proxy_init (UPowerDaemonProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_upower_daemon_dbus_interface_info));
}

static char**
upower_daemon_proxy_enumerate_devices (UPowerDaemon* self,
                                       gint* result_length1,
                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	char** _result = NULL;
	gint _result_length1;
	GVariant* _tmp4_;
	char** _tmp5_;
	gint _tmp5__length;
	gint _tmp5__size;
	gint _tmp5__length1;
	GVariantIter _tmp6_;
	GVariant* _tmp7_;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.UPower", "EnumerateDevices");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp4_ = g_variant_iter_next_value (&_reply_iter);
	_tmp5_ = g_new (char*, 5);
	_tmp5__length = 0;
	_tmp5__size = 4;
	_tmp5__length1 = 0;
	g_variant_iter_init (&_tmp6_, _tmp4_);
	for (; (_tmp7_ = g_variant_iter_next_value (&_tmp6_)) != NULL; _tmp5__length1++) {
		if (_tmp5__size == _tmp5__length) {
			_tmp5__size = 2 * _tmp5__size;
			_tmp5_ = g_renew (char*, _tmp5_, _tmp5__size + 1);
		}
		_tmp5_[_tmp5__length++] = g_variant_dup_string (_tmp7_, NULL);
		g_variant_unref (_tmp7_);
	}
	_result_length1 = _tmp5__length1;
	_tmp5_[_tmp5__length] = NULL;
	_result = _tmp5_;
	g_variant_unref (_tmp4_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
upower_daemon_dbus_proxy_get_daemon_version (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "DaemonVersion");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("DaemonVersion"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_daemon_dbus_proxy_get_on_battery (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "OnBattery");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("OnBattery"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp8_ = FALSE;
			return _tmp8_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_daemon_dbus_proxy_get_on_low_battery (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "OnLowBattery");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("OnLowBattery"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp9_ = FALSE;
			return _tmp9_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_daemon_dbus_proxy_get_lid_is_present (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "LidIsPresent");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("LidIsPresent"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp10_ = FALSE;
			return _tmp10_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_daemon_dbus_proxy_get_lid_is_closed (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "LidIsClosed");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("LidIsClosed"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp11_ = FALSE;
			return _tmp11_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
upower_daemon_proxy_upower_daemon_interface_init (UPowerDaemonIface* iface)
{
	iface->enumerate_devices = upower_daemon_proxy_enumerate_devices;
	iface->get_daemon_version = upower_daemon_dbus_proxy_get_daemon_version;
	iface->get_on_battery = upower_daemon_dbus_proxy_get_on_battery;
	iface->get_on_low_battery = upower_daemon_dbus_proxy_get_on_low_battery;
	iface->get_lid_is_present = upower_daemon_dbus_proxy_get_lid_is_present;
	iface->get_lid_is_closed = upower_daemon_dbus_proxy_get_lid_is_closed;
}

static void
_dbus_upower_daemon_enumerate_devices (UPowerDaemon* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	char** result;
	gint result_length1 = 0;
	char** _tmp12_;
	GVariantBuilder _tmp13_;
	gint _tmp14_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = upower_daemon_enumerate_devices (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp12_ = result;
	g_variant_builder_init (&_tmp13_, G_VARIANT_TYPE ("ao"));
	for (_tmp14_ = 0; _tmp14_ < result_length1; _tmp14_++) {
		g_variant_builder_add_value (&_tmp13_, g_variant_new_object_path (*_tmp12_));
		_tmp12_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp13_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
upower_daemon_dbus_interface_method_call (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* method_name,
                                          GVariant* parameters,
                                          GDBusMethodInvocation* invocation,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "EnumerateDevices") == 0) {
		_dbus_upower_daemon_enumerate_devices (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_upower_daemon_get_daemon_version (UPowerDaemon* self)
{
	gchar* result;
	GVariant* _reply;
	result = upower_daemon_get_daemon_version (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_upower_daemon_get_on_battery (UPowerDaemon* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_daemon_get_on_battery (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_daemon_get_on_low_battery (UPowerDaemon* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_daemon_get_on_low_battery (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_daemon_get_lid_is_present (UPowerDaemon* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_daemon_get_lid_is_present (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_daemon_get_lid_is_closed (UPowerDaemon* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_daemon_get_lid_is_closed (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
upower_daemon_dbus_interface_get_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "DaemonVersion") == 0) {
		return _dbus_upower_daemon_get_daemon_version (object);
	} else if (strcmp (property_name, "OnBattery") == 0) {
		return _dbus_upower_daemon_get_on_battery (object);
	} else if (strcmp (property_name, "OnLowBattery") == 0) {
		return _dbus_upower_daemon_get_on_low_battery (object);
	} else if (strcmp (property_name, "LidIsPresent") == 0) {
		return _dbus_upower_daemon_get_lid_is_present (object);
	} else if (strcmp (property_name, "LidIsClosed") == 0) {
		return _dbus_upower_daemon_get_lid_is_closed (object);
	}
	return NULL;
}

static gboolean
upower_daemon_dbus_interface_set_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GVariant* value,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_upower_daemon_device_added (GObject* _sender,
                                  const char* device,
                                  gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (device));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "DeviceAdded", _arguments, NULL);
}

static void
_dbus_upower_daemon_device_removed (GObject* _sender,
                                    const char* device,
                                    gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (device));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "DeviceRemoved", _arguments, NULL);
}

static void
_dbus_upower_daemon_device_changed (GObject* _sender,
                                    const char* device,
                                    gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (device));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "DeviceChanged", _arguments, NULL);
}

static void
_dbus_upower_daemon_changed (GObject* _sender,
                             gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "Changed", _arguments, NULL);
}

static void
_dbus_upower_daemon_sleeping (GObject* _sender,
                              gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "Sleeping", _arguments, NULL);
}

static void
_dbus_upower_daemon_resuming (GObject* _sender,
                              gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "Resuming", _arguments, NULL);
}

guint
upower_daemon_register_object (gpointer object,
                               GDBusConnection* connection,
                               const gchar* path,
                               GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_upower_daemon_dbus_interface_info), &_upower_daemon_dbus_interface_vtable, data, _upower_daemon_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "device-added", (GCallback) _dbus_upower_daemon_device_added, data);
	g_signal_connect (object, "device-removed", (GCallback) _dbus_upower_daemon_device_removed, data);
	g_signal_connect (object, "device-changed", (GCallback) _dbus_upower_daemon_device_changed, data);
	g_signal_connect (object, "changed", (GCallback) _dbus_upower_daemon_changed, data);
	g_signal_connect (object, "sleeping", (GCallback) _dbus_upower_daemon_sleeping, data);
	g_signal_connect (object, "resuming", (GCallback) _dbus_upower_daemon_resuming, data);
	return result;
}

static void
_upower_daemon_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_device_added, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_device_removed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_device_changed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_changed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_sleeping, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_resuming, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

guint
upower_device_get_Type (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 53 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 53 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 53 "menubar.vala"
	if (_iface_->get_Type) {
#line 53 "menubar.vala"
		return _iface_->get_Type (self);
#line 1499 "menubar.c"
	}
#line 53 "menubar.vala"
	return 0U;
#line 1503 "menubar.c"
}

gboolean
upower_device_get_power_supply (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 54 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 54 "menubar.vala"
	if (_iface_->get_power_supply) {
#line 54 "menubar.vala"
		return _iface_->get_power_supply (self);
#line 1518 "menubar.c"
	}
#line 54 "menubar.vala"
	return FALSE;
#line 1522 "menubar.c"
}

gboolean
upower_device_get_online (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 55 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 55 "menubar.vala"
	if (_iface_->get_online) {
#line 55 "menubar.vala"
		return _iface_->get_online (self);
#line 1537 "menubar.c"
	}
#line 55 "menubar.vala"
	return FALSE;
#line 1541 "menubar.c"
}

gboolean
upower_device_get_is_present (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 56 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 56 "menubar.vala"
	if (_iface_->get_is_present) {
#line 56 "menubar.vala"
		return _iface_->get_is_present (self);
#line 1556 "menubar.c"
	}
#line 56 "menubar.vala"
	return FALSE;
#line 1560 "menubar.c"
}

guint
upower_device_get_state (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 57 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 57 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 57 "menubar.vala"
	if (_iface_->get_state) {
#line 57 "menubar.vala"
		return _iface_->get_state (self);
#line 1575 "menubar.c"
	}
#line 57 "menubar.vala"
	return 0U;
#line 1579 "menubar.c"
}

gboolean
upower_device_get_is_rechargeable (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 58 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 58 "menubar.vala"
	if (_iface_->get_is_rechargeable) {
#line 58 "menubar.vala"
		return _iface_->get_is_rechargeable (self);
#line 1594 "menubar.c"
	}
#line 58 "menubar.vala"
	return FALSE;
#line 1598 "menubar.c"
}

gdouble
upower_device_get_capacity (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 59 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 59 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 59 "menubar.vala"
	if (_iface_->get_capacity) {
#line 59 "menubar.vala"
		return _iface_->get_capacity (self);
#line 1613 "menubar.c"
	}
#line 59 "menubar.vala"
	return -1.0;
#line 1617 "menubar.c"
}

gint64
upower_device_get_time_to_empty (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 60 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 60 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 60 "menubar.vala"
	if (_iface_->get_time_to_empty) {
#line 60 "menubar.vala"
		return _iface_->get_time_to_empty (self);
#line 1632 "menubar.c"
	}
#line 60 "menubar.vala"
	return -1LL;
#line 1636 "menubar.c"
}

gint64
upower_device_get_time_to_full (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 61 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 61 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 61 "menubar.vala"
	if (_iface_->get_time_to_full) {
#line 61 "menubar.vala"
		return _iface_->get_time_to_full (self);
#line 1651 "menubar.c"
	}
#line 61 "menubar.vala"
	return -1LL;
#line 1655 "menubar.c"
}

gdouble
upower_device_get_energy (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 62 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 62 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 62 "menubar.vala"
	if (_iface_->get_energy) {
#line 62 "menubar.vala"
		return _iface_->get_energy (self);
#line 1670 "menubar.c"
	}
#line 62 "menubar.vala"
	return -1.0;
#line 1674 "menubar.c"
}

gdouble
upower_device_get_energy_empty (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 63 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 63 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 63 "menubar.vala"
	if (_iface_->get_energy_empty) {
#line 63 "menubar.vala"
		return _iface_->get_energy_empty (self);
#line 1689 "menubar.c"
	}
#line 63 "menubar.vala"
	return -1.0;
#line 1693 "menubar.c"
}

gdouble
upower_device_get_energy_full (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 64 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 64 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 64 "menubar.vala"
	if (_iface_->get_energy_full) {
#line 64 "menubar.vala"
		return _iface_->get_energy_full (self);
#line 1708 "menubar.c"
	}
#line 64 "menubar.vala"
	return -1.0;
#line 1712 "menubar.c"
}

gdouble
upower_device_get_energy_full_design (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 65 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 65 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 65 "menubar.vala"
	if (_iface_->get_energy_full_design) {
#line 65 "menubar.vala"
		return _iface_->get_energy_full_design (self);
#line 1727 "menubar.c"
	}
#line 65 "menubar.vala"
	return -1.0;
#line 1731 "menubar.c"
}

gdouble
upower_device_get_energy_rate (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 66 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 66 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 66 "menubar.vala"
	if (_iface_->get_energy_rate) {
#line 66 "menubar.vala"
		return _iface_->get_energy_rate (self);
#line 1746 "menubar.c"
	}
#line 66 "menubar.vala"
	return -1.0;
#line 1750 "menubar.c"
}

gdouble
upower_device_get_percentage (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 67 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 67 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 67 "menubar.vala"
	if (_iface_->get_percentage) {
#line 67 "menubar.vala"
		return _iface_->get_percentage (self);
#line 1765 "menubar.c"
	}
#line 67 "menubar.vala"
	return -1.0;
#line 1769 "menubar.c"
}

gdouble
upower_device_get_voltage (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 68 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 68 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 68 "menubar.vala"
	if (_iface_->get_voltage) {
#line 68 "menubar.vala"
		return _iface_->get_voltage (self);
#line 1784 "menubar.c"
	}
#line 68 "menubar.vala"
	return -1.0;
#line 1788 "menubar.c"
}

guint
upower_device_get_technology (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 69 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 69 "menubar.vala"
	if (_iface_->get_technology) {
#line 69 "menubar.vala"
		return _iface_->get_technology (self);
#line 1803 "menubar.c"
	}
#line 69 "menubar.vala"
	return 0U;
#line 1807 "menubar.c"
}

gchar*
upower_device_get_vendor (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 70 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 70 "menubar.vala"
	if (_iface_->get_vendor) {
#line 70 "menubar.vala"
		return _iface_->get_vendor (self);
#line 1822 "menubar.c"
	}
#line 70 "menubar.vala"
	return NULL;
#line 1826 "menubar.c"
}

gchar*
upower_device_get_model (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 71 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 71 "menubar.vala"
	if (_iface_->get_model) {
#line 71 "menubar.vala"
		return _iface_->get_model (self);
#line 1841 "menubar.c"
	}
#line 71 "menubar.vala"
	return NULL;
#line 1845 "menubar.c"
}

gchar*
upower_device_get_serial (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 72 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 72 "menubar.vala"
	if (_iface_->get_serial) {
#line 72 "menubar.vala"
		return _iface_->get_serial (self);
#line 1860 "menubar.c"
	}
#line 72 "menubar.vala"
	return NULL;
#line 1864 "menubar.c"
}

static void
upower_device_default_init (UPowerDeviceIface * iface,
                            gpointer iface_data)
{
#line 50 "menubar.vala"
	upower_device_signals[UPOWER_DEVICE_CHANGED_SIGNAL] = g_signal_new ("changed", UPOWER_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1873 "menubar.c"
}

static GType
upower_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UPowerDeviceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upower_device_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType upower_device_type_id;
	upower_device_type_id = g_type_register_static (G_TYPE_INTERFACE, "UPowerDevice", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (upower_device_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (upower_device_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) upower_device_proxy_get_type);
	g_type_set_qdata (upower_device_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.UPower.Device");
	g_type_set_qdata (upower_device_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_upower_device_dbus_interface_info));
	g_type_set_qdata (upower_device_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) upower_device_register_object);
	return upower_device_type_id;
}

GType
upower_device_get_type (void)
{
	static volatile gsize upower_device_type_id__once = 0;
	if (g_once_init_enter (&upower_device_type_id__once)) {
		GType upower_device_type_id;
		upower_device_type_id = upower_device_get_type_once ();
		g_once_init_leave (&upower_device_type_id__once, upower_device_type_id);
	}
	return upower_device_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (UPowerDeviceProxy, upower_device_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (UPOWER_TYPE_DEVICE, upower_device_proxy_upower_device_interface_init) )
static void
upower_device_proxy_class_init (UPowerDeviceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = upower_device_proxy_g_signal;
}

static void
_dbus_handle_upower_device_changed (UPowerDevice* self,
                                    GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "changed");
}

static void
upower_device_proxy_g_signal (GDBusProxy* proxy,
                              const gchar* sender_name,
                              const gchar* signal_name,
                              GVariant* parameters)
{
	if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_upower_device_changed ((UPowerDevice*) proxy, parameters);
	}
}

static void
upower_device_proxy_init (UPowerDeviceProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_upower_device_dbus_interface_info));
}

static guint
upower_device_dbus_proxy_get_Type (UPowerDevice* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Type");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Type"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp15_ = 0U;
			return _tmp15_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_device_dbus_proxy_get_power_supply (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "PowerSupply");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PowerSupply"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp16_ = FALSE;
			return _tmp16_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_device_dbus_proxy_get_online (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Online");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Online"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp17_ = FALSE;
			return _tmp17_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_device_dbus_proxy_get_is_present (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "IsPresent");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("IsPresent"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp18_ = FALSE;
			return _tmp18_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static guint
upower_device_dbus_proxy_get_state (UPowerDevice* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "State");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("State"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp19_ = 0U;
			return _tmp19_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_device_dbus_proxy_get_is_rechargeable (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "IsRechargeable");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("IsRechargeable"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp20_ = FALSE;
			return _tmp20_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_capacity (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Capacity");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Capacity"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp21_ = 0.0;
			return _tmp21_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gint64
upower_device_dbus_proxy_get_time_to_empty (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gint64 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "TimeToEmpty");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("TimeToEmpty"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint64 _tmp22_ = 0LL;
			return _tmp22_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int64 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gint64
upower_device_dbus_proxy_get_time_to_full (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gint64 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "TimeToFull");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("TimeToFull"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint64 _tmp23_ = 0LL;
			return _tmp23_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int64 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Energy");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Energy"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp24_ = 0.0;
			return _tmp24_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy_empty (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "EnergyEmpty");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("EnergyEmpty"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp25_ = 0.0;
			return _tmp25_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy_full (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "EnergyFull");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("EnergyFull"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp26_ = 0.0;
			return _tmp26_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy_full_design (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "EnergyFullDesign");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("EnergyFullDesign"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp27_ = 0.0;
			return _tmp27_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy_rate (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "EnergyRate");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("EnergyRate"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp28_ = 0.0;
			return _tmp28_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_percentage (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Percentage");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Percentage"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp29_ = 0.0;
			return _tmp29_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_voltage (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Voltage");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Voltage"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp30_ = 0.0;
			return _tmp30_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static guint
upower_device_dbus_proxy_get_technology (UPowerDevice* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Technology");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Technology"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp31_ = 0U;
			return _tmp31_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar*
upower_device_dbus_proxy_get_vendor (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Vendor");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Vendor"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar*
upower_device_dbus_proxy_get_model (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Model");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Model"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar*
upower_device_dbus_proxy_get_serial (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Serial");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Serial"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
upower_device_proxy_upower_device_interface_init (UPowerDeviceIface* iface)
{
	iface->get_Type = upower_device_dbus_proxy_get_Type;
	iface->get_power_supply = upower_device_dbus_proxy_get_power_supply;
	iface->get_online = upower_device_dbus_proxy_get_online;
	iface->get_is_present = upower_device_dbus_proxy_get_is_present;
	iface->get_state = upower_device_dbus_proxy_get_state;
	iface->get_is_rechargeable = upower_device_dbus_proxy_get_is_rechargeable;
	iface->get_capacity = upower_device_dbus_proxy_get_capacity;
	iface->get_time_to_empty = upower_device_dbus_proxy_get_time_to_empty;
	iface->get_time_to_full = upower_device_dbus_proxy_get_time_to_full;
	iface->get_energy = upower_device_dbus_proxy_get_energy;
	iface->get_energy_empty = upower_device_dbus_proxy_get_energy_empty;
	iface->get_energy_full = upower_device_dbus_proxy_get_energy_full;
	iface->get_energy_full_design = upower_device_dbus_proxy_get_energy_full_design;
	iface->get_energy_rate = upower_device_dbus_proxy_get_energy_rate;
	iface->get_percentage = upower_device_dbus_proxy_get_percentage;
	iface->get_voltage = upower_device_dbus_proxy_get_voltage;
	iface->get_technology = upower_device_dbus_proxy_get_technology;
	iface->get_vendor = upower_device_dbus_proxy_get_vendor;
	iface->get_model = upower_device_dbus_proxy_get_model;
	iface->get_serial = upower_device_dbus_proxy_get_serial;
}

static void
upower_device_dbus_interface_method_call (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* method_name,
                                          GVariant* parameters,
                                          GDBusMethodInvocation* invocation,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
_dbus_upower_device_get_Type (UPowerDevice* self)
{
	guint result;
	GVariant* _reply;
	result = upower_device_get_Type (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_power_supply (UPowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_device_get_power_supply (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_online (UPowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_device_get_online (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_is_present (UPowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_device_get_is_present (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_state (UPowerDevice* self)
{
	guint result;
	GVariant* _reply;
	result = upower_device_get_state (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_is_rechargeable (UPowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_device_get_is_rechargeable (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_capacity (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_capacity (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_time_to_empty (UPowerDevice* self)
{
	gint64 result;
	GVariant* _reply;
	result = upower_device_get_time_to_empty (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_time_to_full (UPowerDevice* self)
{
	gint64 result;
	GVariant* _reply;
	result = upower_device_get_time_to_full (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy_empty (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy_empty (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy_full (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy_full (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy_full_design (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy_full_design (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy_rate (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy_rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_percentage (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_percentage (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_voltage (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_voltage (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_technology (UPowerDevice* self)
{
	guint result;
	GVariant* _reply;
	result = upower_device_get_technology (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_vendor (UPowerDevice* self)
{
	gchar* result;
	GVariant* _reply;
	result = upower_device_get_vendor (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_model (UPowerDevice* self)
{
	gchar* result;
	GVariant* _reply;
	result = upower_device_get_model (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_serial (UPowerDevice* self)
{
	gchar* result;
	GVariant* _reply;
	result = upower_device_get_serial (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
upower_device_dbus_interface_get_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Type") == 0) {
		return _dbus_upower_device_get_Type (object);
	} else if (strcmp (property_name, "PowerSupply") == 0) {
		return _dbus_upower_device_get_power_supply (object);
	} else if (strcmp (property_name, "Online") == 0) {
		return _dbus_upower_device_get_online (object);
	} else if (strcmp (property_name, "IsPresent") == 0) {
		return _dbus_upower_device_get_is_present (object);
	} else if (strcmp (property_name, "State") == 0) {
		return _dbus_upower_device_get_state (object);
	} else if (strcmp (property_name, "IsRechargeable") == 0) {
		return _dbus_upower_device_get_is_rechargeable (object);
	} else if (strcmp (property_name, "Capacity") == 0) {
		return _dbus_upower_device_get_capacity (object);
	} else if (strcmp (property_name, "TimeToEmpty") == 0) {
		return _dbus_upower_device_get_time_to_empty (object);
	} else if (strcmp (property_name, "TimeToFull") == 0) {
		return _dbus_upower_device_get_time_to_full (object);
	} else if (strcmp (property_name, "Energy") == 0) {
		return _dbus_upower_device_get_energy (object);
	} else if (strcmp (property_name, "EnergyEmpty") == 0) {
		return _dbus_upower_device_get_energy_empty (object);
	} else if (strcmp (property_name, "EnergyFull") == 0) {
		return _dbus_upower_device_get_energy_full (object);
	} else if (strcmp (property_name, "EnergyFullDesign") == 0) {
		return _dbus_upower_device_get_energy_full_design (object);
	} else if (strcmp (property_name, "EnergyRate") == 0) {
		return _dbus_upower_device_get_energy_rate (object);
	} else if (strcmp (property_name, "Percentage") == 0) {
		return _dbus_upower_device_get_percentage (object);
	} else if (strcmp (property_name, "Voltage") == 0) {
		return _dbus_upower_device_get_voltage (object);
	} else if (strcmp (property_name, "Technology") == 0) {
		return _dbus_upower_device_get_technology (object);
	} else if (strcmp (property_name, "Vendor") == 0) {
		return _dbus_upower_device_get_vendor (object);
	} else if (strcmp (property_name, "Model") == 0) {
		return _dbus_upower_device_get_model (object);
	} else if (strcmp (property_name, "Serial") == 0) {
		return _dbus_upower_device_get_serial (object);
	}
	return NULL;
}

static gboolean
upower_device_dbus_interface_set_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GVariant* value,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_upower_device_changed (GObject* _sender,
                             gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower.Device", "Changed", _arguments, NULL);
}

guint
upower_device_register_object (gpointer object,
                               GDBusConnection* connection,
                               const gchar* path,
                               GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_upower_device_dbus_interface_info), &_upower_device_dbus_interface_vtable, data, _upower_device_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "changed", (GCallback) _dbus_upower_device_changed, data);
	return result;
}

static void
_upower_device_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_device_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
menu_bar_get_instance_private (MenuBar* self)
{
	return G_STRUCT_MEMBER_P (self, MenuBar_private_offset);
}

MenuBar*
menu_bar_construct (GType object_type,
                    Background* bg,
                    GtkAccelGroup* ag,
                    MainWindow* mw)
{
	MenuBar * self = NULL;
#line 88 "menubar.vala"
	g_return_val_if_fail (bg != NULL, NULL);
#line 88 "menubar.vala"
	g_return_val_if_fail (ag != NULL, NULL);
#line 88 "menubar.vala"
	g_return_val_if_fail (mw != NULL, NULL);
#line 90 "menubar.vala"
	self = (MenuBar*) g_object_new (object_type, "background", bg, "accel-group", ag, "main-window", mw, NULL);
#line 88 "menubar.vala"
	return self;
#line 2861 "menubar.c"
}

MenuBar*
menu_bar_new (Background* bg,
              GtkAccelGroup* ag,
              MainWindow* mw)
{
#line 88 "menubar.vala"
	return menu_bar_construct (TYPE_MENU_BAR, bg, ag, mw);
#line 2871 "menubar.c"
}

static gboolean
menu_bar_real_draw (GtkWidget* base,
                    cairo_t* c)
{
	MenuBar * self;
	Background* _tmp0_;
	GList* _tmp5_;
	gboolean result;
#line 93 "menubar.vala"
	self = (MenuBar*) base;
#line 93 "menubar.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 95 "menubar.vala"
	_tmp0_ = self->priv->_background;
#line 95 "menubar.vala"
	if (_tmp0_ != NULL) {
#line 2890 "menubar.c"
		gint x = 0;
		gint y = 0;
		Background* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		Background* _tmp4_;
#line 98 "menubar.vala"
		_tmp1_ = self->priv->_background;
#line 98 "menubar.vala"
		gtk_widget_translate_coordinates ((GtkWidget*) _tmp1_, (GtkWidget*) self, 0, 0, &_tmp2_, &_tmp3_);
#line 98 "menubar.vala"
		x = _tmp2_;
#line 98 "menubar.vala"
		y = _tmp3_;
#line 99 "menubar.vala"
		cairo_save (c);
#line 100 "menubar.vala"
		cairo_translate (c, (gdouble) x, (gdouble) y);
#line 101 "menubar.vala"
		_tmp4_ = self->priv->_background;
#line 101 "menubar.vala"
		background_draw_full (_tmp4_, c, BACKGROUND_DRAW_FLAGS_NONE);
#line 102 "menubar.vala"
		cairo_restore (c);
#line 2915 "menubar.c"
	}
#line 105 "menubar.vala"
	cairo_set_source_rgb (c, 0.1, 0.1, 0.1);
#line 106 "menubar.vala"
	cairo_paint_with_alpha (c, 0.4);
#line 108 "menubar.vala"
	_tmp5_ = gtk_container_get_children ((GtkContainer*) self);
#line 2923 "menubar.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 108 "menubar.vala"
		child_collection = _tmp5_;
#line 108 "menubar.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 2931 "menubar.c"
			GtkWidget* child = NULL;
#line 108 "menubar.vala"
			child = (GtkWidget*) child_it->data;
#line 2935 "menubar.c"
			{
				GtkWidget* _tmp6_;
#line 110 "menubar.vala"
				_tmp6_ = child;
#line 110 "menubar.vala"
				gtk_container_propagate_draw ((GtkContainer*) self, _tmp6_, c);
#line 2942 "menubar.c"
			}
		}
#line 108 "menubar.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 2947 "menubar.c"
	}
#line 113 "menubar.vala"
	result = FALSE;
#line 113 "menubar.vala"
	return result;
#line 2953 "menubar.c"
}

void
menu_bar_set_keyboard_state (MenuBar* self)
{
	GtkCheckMenuItem* _tmp0_;
#line 120 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 122 "menubar.vala"
	_tmp0_ = self->priv->onscreen_keyboard_item;
#line 122 "menubar.vala"
	gtk_check_menu_item_set_active (_tmp0_, ug_settings_get_boolean (UG_SETTINGS_KEY_ONSCREEN_KEYBOARD));
#line 2966 "menubar.c"
}

static void
menu_bar_on_sleeping (MenuBar* self)
{
#line 243 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 2974 "menubar.c"
}

static void
menu_bar_on_resuming (MenuBar* self)
{
#line 247 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 249 "menubar.vala"
	menu_bar_query_upower_daemon (self);
#line 2984 "menubar.c"
}

static void
menu_bar_on_changed (MenuBar* self)
{
#line 252 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 254 "menubar.vala"
	menu_bar_query_upower_daemon (self);
#line 2994 "menubar.c"
}

static void
menu_bar_on_power_device_added (MenuBar* self,
                                const char* device)
{
#line 257 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 257 "menubar.vala"
	g_return_if_fail (device != NULL);
#line 259 "menubar.vala"
	menu_bar_query_upower_device (self, device, NULL, NULL);
#line 3007 "menubar.c"
}

static void
menu_bar_on_power_device_changed (MenuBar* self,
                                  const char* device)
{
#line 262 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 262 "menubar.vala"
	g_return_if_fail (device != NULL);
#line 264 "menubar.vala"
	menu_bar_query_upower_device (self, device, NULL, NULL);
#line 3020 "menubar.c"
}

static gboolean
menu_bar_query_upower_daemon (MenuBar* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 267 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3030 "menubar.c"
	{
		UPowerDaemon* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 270 "menubar.vala"
		_tmp0_ = self->priv->upowerd;
#line 270 "menubar.vala"
		_tmp1_ = upower_daemon_get_on_battery (_tmp0_);
#line 270 "menubar.vala"
		_tmp2_ = _tmp1_;
#line 270 "menubar.vala"
		if (_tmp2_ == TRUE) {
#line 3043 "menubar.c"
			char** _tmp3_ = NULL;
			UPowerDaemon* _tmp4_;
			gint _tmp5_ = 0;
			char** _tmp6_;
			gint _tmp3__length1;
			gint __tmp3__size_;
#line 271 "menubar.vala"
			_tmp4_ = self->priv->upowerd;
#line 271 "menubar.vala"
			_tmp6_ = upower_daemon_enumerate_devices (_tmp4_, &_tmp5_, &_inner_error0_);
#line 271 "menubar.vala"
			_tmp3_ = _tmp6_;
#line 271 "menubar.vala"
			_tmp3__length1 = _tmp5_;
#line 271 "menubar.vala"
			__tmp3__size_ = _tmp3__length1;
#line 271 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3062 "menubar.c"
				goto __catch0_g_error;
			}
			{
				char** o_collection = NULL;
				gint o_collection_length1 = 0;
				gint _o_collection_size_ = 0;
				gint o_it = 0;
#line 271 "menubar.vala"
				o_collection = _tmp3_;
#line 271 "menubar.vala"
				o_collection_length1 = _tmp3__length1;
#line 271 "menubar.vala"
				for (o_it = 0; o_it < o_collection_length1; o_it = o_it + 1) {
#line 3076 "menubar.c"
					char* _tmp7_;
					char* o = NULL;
#line 271 "menubar.vala"
					_tmp7_ = g_strdup (o_collection[o_it]);
#line 271 "menubar.vala"
					o = _tmp7_;
#line 3083 "menubar.c"
					{
						const char* _tmp8_;
#line 272 "menubar.vala"
						_tmp8_ = o;
#line 272 "menubar.vala"
						menu_bar_query_upower_device (self, _tmp8_, NULL, NULL);
#line 271 "menubar.vala"
						_g_free0 (o);
#line 3092 "menubar.c"
					}
				}
			}
#line 270 "menubar.vala"
			_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 3098 "menubar.c"
		} else {
			GtkMenuItem* _tmp9_;
#line 276 "menubar.vala"
			_tmp9_ = self->priv->power_menu_item;
#line 276 "menubar.vala"
			gtk_widget_hide ((GtkWidget*) _tmp9_);
#line 3105 "menubar.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 269 "menubar.vala"
		e = _inner_error0_;
#line 269 "menubar.vala"
		_inner_error0_ = NULL;
#line 280 "menubar.vala"
		_tmp10_ = e;
#line 280 "menubar.vala"
		_tmp11_ = _tmp10_->message;
#line 280 "menubar.vala"
		g_warning ("menubar.vala:280: Error while querying upower daemon: %s", _tmp11_);
#line 269 "menubar.vala"
		_g_error_free0 (e);
#line 3126 "menubar.c"
	}
	__finally0:
#line 269 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3131 "menubar.c"
		gboolean _tmp12_ = FALSE;
#line 269 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 269 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 269 "menubar.vala"
		return _tmp12_;
#line 3139 "menubar.c"
	}
#line 282 "menubar.vala"
	result = TRUE;
#line 282 "menubar.vala"
	return result;
#line 3145 "menubar.c"
}

static void
menu_bar_query_upower_device_data_free (gpointer _data)
{
	MenuBarQueryUpowerDeviceData* _data_;
	_data_ = _data;
#line 78 "menubar.vala"
	_g_free0 (_data_->dev_path);
#line 78 "menubar.vala"
	_g_object_unref0 (_data_->self);
#line 78 "menubar.vala"
	g_slice_free (MenuBarQueryUpowerDeviceData, _data_);
#line 3159 "menubar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 78 "menubar.vala"
	return self ? g_object_ref (self) : NULL;
#line 3167 "menubar.c"
}

static void
menu_bar_query_upower_device (MenuBar* self,
                              const char* dev_path,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	MenuBarQueryUpowerDeviceData* _data_;
	MenuBar* _tmp0_;
	char* _tmp1_;
#line 78 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 78 "menubar.vala"
	g_return_if_fail (dev_path != NULL);
#line 78 "menubar.vala"
	_data_ = g_slice_new0 (MenuBarQueryUpowerDeviceData);
#line 78 "menubar.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 78 "menubar.vala"
	g_task_set_task_data (_data_->_async_result, _data_, menu_bar_query_upower_device_data_free);
#line 78 "menubar.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 78 "menubar.vala"
	_data_->self = _tmp0_;
#line 78 "menubar.vala"
	_tmp1_ = g_strdup (dev_path);
#line 78 "menubar.vala"
	_g_free0 (_data_->dev_path);
#line 78 "menubar.vala"
	_data_->dev_path = _tmp1_;
#line 78 "menubar.vala"
	menu_bar_query_upower_device_co (_data_);
#line 3201 "menubar.c"
}

static void
menu_bar_query_upower_device_finish (MenuBar* self,
                                     GAsyncResult* _res_)
{
	MenuBarQueryUpowerDeviceData* _data_;
#line 78 "menubar.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3211 "menubar.c"
}

static gboolean
menu_bar_query_upower_device_co (MenuBarQueryUpowerDeviceData* _data_)
{
#line 285 "menubar.vala"
	switch (_data_->_state_) {
#line 285 "menubar.vala"
		case 0:
#line 3221 "menubar.c"
		goto _state_0;
		default:
#line 285 "menubar.vala"
		g_assert_not_reached ();
#line 3226 "menubar.c"
	}
	_state_0:
	{
#line 291 "menubar.vala"
		_data_->_tmp1_ = (UPowerDevice*) g_initable_new (UPOWER_TYPE_DEVICE_PROXY, NULL, &_data_->_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.UPower", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", (const gchar*) _data_->dev_path, "g-interface-name", "org.freedesktop.UPower.Device", NULL);
#line 291 "menubar.vala"
		_data_->_tmp0_ = (UPowerDevice*) _data_->_tmp1_;
#line 291 "menubar.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 291 "menubar.vala"
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3238 "menubar.c"
				goto __catch0_g_io_error;
			}
#line 291 "menubar.vala"
			_g_object_unref0 (_data_->dev);
#line 291 "menubar.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 291 "menubar.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 291 "menubar.vala"
			g_object_unref (_data_->_async_result);
#line 291 "menubar.vala"
			return FALSE;
#line 3251 "menubar.c"
		}
#line 291 "menubar.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 291 "menubar.vala"
		_data_->_tmp0_ = NULL;
#line 291 "menubar.vala"
		_g_object_unref0 (_data_->dev);
#line 291 "menubar.vala"
		_data_->dev = _data_->_tmp2_;
#line 290 "menubar.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 3263 "menubar.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
#line 290 "menubar.vala"
		_data_->io = _data_->_inner_error0_;
#line 290 "menubar.vala"
		_data_->_inner_error0_ = NULL;
#line 293 "menubar.vala"
		_data_->_tmp3_ = _data_->io;
#line 293 "menubar.vala"
		_data_->_tmp4_ = _data_->_tmp3_->message;
#line 293 "menubar.vala"
		g_warning ("menubar.vala:293: Could not connect to UPower/Device: %s", _data_->_tmp4_);
#line 294 "menubar.vala"
		_g_error_free0 (_data_->io);
#line 294 "menubar.vala"
		_g_object_unref0 (_data_->dev);
#line 294 "menubar.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 294 "menubar.vala"
		if (_data_->_state_ != 0) {
#line 294 "menubar.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 294 "menubar.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3290 "menubar.c"
			}
		}
#line 294 "menubar.vala"
		g_object_unref (_data_->_async_result);
#line 294 "menubar.vala"
		return FALSE;
#line 3297 "menubar.c"
	}
	__finally0:
#line 290 "menubar.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 290 "menubar.vala"
		_g_object_unref0 (_data_->dev);
#line 290 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 290 "menubar.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 290 "menubar.vala"
		g_object_unref (_data_->_async_result);
#line 290 "menubar.vala"
		return FALSE;
#line 3312 "menubar.c"
	}
#line 298 "menubar.vala"
	_data_->_tmp5_ = _data_->dev;
#line 298 "menubar.vala"
	_data_->_tmp6_ = upower_device_get_Type (_data_->_tmp5_);
#line 298 "menubar.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 298 "menubar.vala"
	_data_->type = _data_->_tmp7_;
#line 299 "menubar.vala"
	if (_data_->type == ((guint) 1)) {
#line 3324 "menubar.c"
	} else {
#line 300 "menubar.vala"
		if (_data_->type == ((guint) 2)) {
#line 300 "menubar.vala"
			_data_->_tmp9_ = _data_->dev;
#line 300 "menubar.vala"
			_data_->_tmp10_ = upower_device_get_is_present (_data_->_tmp9_);
#line 300 "menubar.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 300 "menubar.vala"
			_data_->_tmp8_ = _data_->_tmp11_ == TRUE;
#line 3336 "menubar.c"
		} else {
#line 300 "menubar.vala"
			_data_->_tmp8_ = FALSE;
#line 3340 "menubar.c"
		}
#line 300 "menubar.vala"
		if (_data_->_tmp8_) {
#line 301 "menubar.vala"
			_data_->_tmp12_ = _data_->dev;
#line 301 "menubar.vala"
			menu_bar_update_power (_data_->self, _data_->_tmp12_);
#line 3348 "menubar.c"
		} else {
#line 302 "menubar.vala"
			if (_data_->type == ((guint) 3)) {
#line 3352 "menubar.c"
			} else {
#line 303 "menubar.vala"
				if (_data_->type == ((guint) 5)) {
#line 3356 "menubar.c"
				} else {
#line 304 "menubar.vala"
					if (_data_->type == ((guint) 6)) {
#line 3360 "menubar.c"
					} else {
#line 305 "menubar.vala"
						if (_data_->type == ((guint) 7)) {
#line 3364 "menubar.c"
						} else {
#line 306 "menubar.vala"
							if (_data_->type == ((guint) 8)) {
#line 3368 "menubar.c"
							}
						}
					}
				}
			}
		}
	}
#line 285 "menubar.vala"
	_g_object_unref0 (_data_->dev);
#line 285 "menubar.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 285 "menubar.vala"
	if (_data_->_state_ != 0) {
#line 285 "menubar.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 285 "menubar.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3386 "menubar.c"
		}
	}
#line 285 "menubar.vala"
	g_object_unref (_data_->_async_result);
#line 285 "menubar.vala"
	return FALSE;
#line 3393 "menubar.c"
}

static void
menu_bar_on_power_device_removed (MenuBar* self,
                                  const char* device)
{
#line 310 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 310 "menubar.vala"
	g_return_if_fail (device != NULL);
#line 312 "menubar.vala"
	menu_bar_query_upower_daemon (self);
#line 3406 "menubar.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 3437 "menubar.c"
}

static void
menu_bar_update_power (MenuBar* self,
                       UPowerDevice* device)
{
#line 315 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 317 "menubar.vala"
	if (device == NULL) {
#line 3448 "menubar.c"
		GtkMenuItem* _tmp0_;
#line 318 "menubar.vala"
		_tmp0_ = self->priv->power_menu_item;
#line 318 "menubar.vala"
		gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 3454 "menubar.c"
	} else {
		gchar* str = NULL;
		gdouble _tmp1_;
		gdouble _tmp2_;
		gchar* _tmp3_;
		gchar* percentage_string = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		GtkLabel* _tmp6_;
		const gchar* _tmp7_;
		GtkMenuItem* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* icon = NULL;
		gchar* _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp21_;
		gdouble _tmp22_;
		GtkImage* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GtkMenuItem* _tmp28_;
#line 321 "menubar.vala"
		_tmp1_ = upower_device_get_percentage (device);
#line 321 "menubar.vala"
		_tmp2_ = _tmp1_;
#line 321 "menubar.vala"
		_tmp3_ = double_to_string (round (_tmp2_));
#line 321 "menubar.vala"
		str = _tmp3_;
#line 322 "menubar.vala"
		_tmp4_ = str;
#line 322 "menubar.vala"
		_tmp5_ = g_strconcat (_tmp4_, "%", NULL);
#line 322 "menubar.vala"
		percentage_string = _tmp5_;
#line 323 "menubar.vala"
		_tmp6_ = self->priv->power_label;
#line 323 "menubar.vala"
		_tmp7_ = percentage_string;
#line 323 "menubar.vala"
		gtk_label_set_label (_tmp6_, _tmp7_);
#line 324 "menubar.vala"
		_tmp8_ = self->priv->power_menu_item;
#line 324 "menubar.vala"
		_tmp9_ = g_strconcat (_ ("Power:"), " ", NULL);
#line 324 "menubar.vala"
		_tmp10_ = _tmp9_;
#line 324 "menubar.vala"
		_tmp11_ = percentage_string;
#line 324 "menubar.vala"
		_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 324 "menubar.vala"
		_tmp13_ = _tmp12_;
#line 324 "menubar.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _tmp13_);
#line 324 "menubar.vala"
		_g_free0 (_tmp13_);
#line 324 "menubar.vala"
		_g_free0 (_tmp10_);
#line 325 "menubar.vala"
		_tmp14_ = g_strdup ("battery.svg");
#line 325 "menubar.vala"
		icon = _tmp14_;
#line 326 "menubar.vala"
		_tmp15_ = upower_device_get_percentage (device);
#line 326 "menubar.vala"
		_tmp16_ = _tmp15_;
#line 326 "menubar.vala"
		if (_tmp16_ <= 50.0) {
#line 3532 "menubar.c"
			gchar* _tmp17_;
#line 327 "menubar.vala"
			_tmp17_ = g_strdup ("battery_50.svg");
#line 327 "menubar.vala"
			_g_free0 (icon);
#line 327 "menubar.vala"
			icon = _tmp17_;
#line 3540 "menubar.c"
		}
#line 329 "menubar.vala"
		_tmp18_ = upower_device_get_percentage (device);
#line 329 "menubar.vala"
		_tmp19_ = _tmp18_;
#line 329 "menubar.vala"
		if (_tmp19_ <= 25.0) {
#line 3548 "menubar.c"
			gchar* _tmp20_;
#line 330 "menubar.vala"
			_tmp20_ = g_strdup ("battery_25.svg");
#line 330 "menubar.vala"
			_g_free0 (icon);
#line 330 "menubar.vala"
			icon = _tmp20_;
#line 3556 "menubar.c"
		}
#line 332 "menubar.vala"
		_tmp21_ = upower_device_get_percentage (device);
#line 332 "menubar.vala"
		_tmp22_ = _tmp21_;
#line 332 "menubar.vala"
		if (_tmp22_ <= 10.0) {
#line 3564 "menubar.c"
			gchar* _tmp23_;
#line 333 "menubar.vala"
			_tmp23_ = g_strdup ("battery_10.svg");
#line 333 "menubar.vala"
			_g_free0 (icon);
#line 333 "menubar.vala"
			icon = _tmp23_;
#line 3572 "menubar.c"
		}
#line 335 "menubar.vala"
		_tmp24_ = self->priv->power_icon;
#line 335 "menubar.vala"
		_tmp25_ = icon;
#line 335 "menubar.vala"
		_tmp26_ = g_build_filename (PKGDATADIR, _tmp25_, NULL);
#line 335 "menubar.vala"
		_tmp27_ = _tmp26_;
#line 335 "menubar.vala"
		gtk_image_set_from_file (_tmp24_, _tmp27_);
#line 335 "menubar.vala"
		_g_free0 (_tmp27_);
#line 336 "menubar.vala"
		_tmp28_ = self->priv->power_menu_item;
#line 336 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp28_);
#line 317 "menubar.vala"
		_g_free0 (icon);
#line 317 "menubar.vala"
		_g_free0 (percentage_string);
#line 317 "menubar.vala"
		_g_free0 (str);
#line 3596 "menubar.c"
	}
}

static gboolean
menu_bar_update_clock (MenuBar* self)
{
	GDateTime* current_time = NULL;
	GDateTime* _tmp0_;
	GtkLabel* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean result;
#line 340 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 342 "menubar.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 342 "menubar.vala"
	current_time = _tmp0_;
#line 343 "menubar.vala"
	_tmp1_ = self->priv->clock_label;
#line 343 "menubar.vala"
	_tmp2_ = self->priv->clock_format;
#line 343 "menubar.vala"
	_tmp3_ = g_date_time_format (current_time, _tmp2_);
#line 343 "menubar.vala"
	_tmp4_ = _tmp3_;
#line 343 "menubar.vala"
	gtk_label_set_label (_tmp1_, _tmp4_);
#line 343 "menubar.vala"
	_g_free0 (_tmp4_);
#line 344 "menubar.vala"
	_tmp5_ = self->priv->clock_label;
#line 344 "menubar.vala"
	_tmp6_ = g_date_time_format (current_time, "%x");
#line 344 "menubar.vala"
	_tmp7_ = _tmp6_;
#line 344 "menubar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp5_, _tmp7_);
#line 344 "menubar.vala"
	_g_free0 (_tmp7_);
#line 345 "menubar.vala"
	result = TRUE;
#line 345 "menubar.vala"
	_g_date_time_unref0 (current_time);
#line 345 "menubar.vala"
	return result;
#line 3647 "menubar.c"
}

static void
menu_bar_close_pid (MenuBar* self,
                    GPid* pid)
{
#line 348 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 350 "menubar.vala"
	if ((*pid) > ((GPid) 0)) {
#line 3658 "menubar.c"
		gint status = 0;
		gint _tmp0_ = 0;
#line 352 "menubar.vala"
		kill ((pid_t) (*pid), (gint) SIGTERM);
#line 354 "menubar.vala"
		waitpid ((pid_t) (*pid), &_tmp0_, 0);
#line 354 "menubar.vala"
		status = _tmp0_;
#line 355 "menubar.vala"
		*pid = (GPid) 0;
#line 3669 "menubar.c"
	}
}

void
menu_bar_cleanup (MenuBar* self)
{
#line 359 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 361 "menubar.vala"
	menu_bar_close_pid (self, &self->priv->keyboard_pid);
#line 362 "menubar.vala"
	menu_bar_close_pid (self, &self->priv->reader_pid);
#line 3682 "menubar.c"
}

static void
menu_bar_real_get_preferred_height (GtkWidget* base,
                                    gint* min,
                                    gint* nat)
{
	MenuBar * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
#line 365 "menubar.vala"
	self = (MenuBar*) base;
#line 367 "menubar.vala"
	_vala_min = MENU_BAR_HEIGHT;
#line 368 "menubar.vala"
	_vala_nat = MENU_BAR_HEIGHT;
#line 365 "menubar.vala"
	if (min) {
#line 365 "menubar.vala"
		*min = _vala_min;
#line 3703 "menubar.c"
	}
#line 365 "menubar.vala"
	if (nat) {
#line 365 "menubar.vala"
		*nat = _vala_nat;
#line 3709 "menubar.c"
	}
}

static void
_menu_bar_keyboard_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                           gpointer self)
{
#line 384 "menubar.vala"
	menu_bar_keyboard_toggled_cb ((MenuBar*) self, _sender);
#line 3719 "menubar.c"
}

static void
_menu_bar_high_contrast_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 389 "menubar.vala"
	menu_bar_high_contrast_toggled_cb ((MenuBar*) self, _sender);
#line 3728 "menubar.c"
}

static void
_menu_bar_screen_reader_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 395 "menubar.vala"
	menu_bar_screen_reader_toggled_cb ((MenuBar*) self, _sender);
#line 3737 "menubar.c"
}

static GtkMenuItem*
menu_bar_make_a11y_item (MenuBar* self)
{
	GtkMenuItem* a11y_item = NULL;
	GtkMenuItem* _tmp0_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp1_;
	GtkImage* image = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
	GtkCheckMenuItem* _tmp8_;
	GtkCheckMenuItem* _tmp9_;
	GtkCheckMenuItem* _tmp10_;
	GtkMenu* submenu = NULL;
	GtkMenu* _tmp11_;
	GtkMenu* _tmp12_;
	GtkCheckMenuItem* _tmp13_;
	GtkCheckMenuItem* _tmp14_;
	GtkCheckMenuItem* _tmp15_;
	GtkCheckMenuItem* _tmp16_;
	GtkAccelGroup* _tmp17_;
	GtkCheckMenuItem* _tmp18_;
	GtkCheckMenuItem* _tmp19_;
	GtkCheckMenuItem* _tmp20_;
	GtkCheckMenuItem* item = NULL;
	GtkCheckMenuItem* _tmp21_;
	GtkAccelGroup* _tmp22_;
	GtkMenuItem* result;
#line 371 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 373 "menubar.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 373 "menubar.vala"
	g_object_ref_sink (_tmp0_);
#line 373 "menubar.vala"
	a11y_item = _tmp0_;
#line 374 "menubar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) a11y_item, _ ("Accessibility"));
#line 375 "menubar.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 375 "menubar.vala"
	g_object_ref_sink (_tmp1_);
#line 375 "menubar.vala"
	hbox = _tmp1_;
#line 376 "menubar.vala"
	gtk_widget_show ((GtkWidget*) hbox);
#line 377 "menubar.vala"
	gtk_container_add ((GtkContainer*) a11y_item, (GtkWidget*) hbox);
#line 378 "menubar.vala"
	_tmp2_ = g_build_filename (PKGDATADIR, "a11y.svg", NULL);
#line 378 "menubar.vala"
	_tmp3_ = _tmp2_;
#line 378 "menubar.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_file (_tmp3_);
#line 378 "menubar.vala"
	g_object_ref_sink (_tmp4_);
#line 378 "menubar.vala"
	_tmp5_ = _tmp4_;
#line 378 "menubar.vala"
	_g_free0 (_tmp3_);
#line 378 "menubar.vala"
	image = _tmp5_;
#line 379 "menubar.vala"
	gtk_widget_show ((GtkWidget*) image);
#line 380 "menubar.vala"
	gtk_container_add ((GtkContainer*) hbox, (GtkWidget*) image);
#line 381 "menubar.vala"
	gtk_widget_show ((GtkWidget*) a11y_item);
#line 382 "menubar.vala"
	_tmp6_ = (GtkMenu*) gtk_menu_new ();
#line 382 "menubar.vala"
	g_object_ref_sink (_tmp6_);
#line 382 "menubar.vala"
	_tmp7_ = _tmp6_;
#line 382 "menubar.vala"
	gtk_menu_item_set_submenu (a11y_item, _tmp7_);
#line 382 "menubar.vala"
	_g_object_unref0 (_tmp7_);
#line 383 "menubar.vala"
	_tmp8_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Onscreen keyboard"));
#line 383 "menubar.vala"
	g_object_ref_sink (_tmp8_);
#line 383 "menubar.vala"
	_g_object_unref0 (self->priv->onscreen_keyboard_item);
#line 383 "menubar.vala"
	self->priv->onscreen_keyboard_item = _tmp8_;
#line 384 "menubar.vala"
	_tmp9_ = self->priv->onscreen_keyboard_item;
#line 384 "menubar.vala"
	g_signal_connect_object (_tmp9_, "toggled", (GCallback) _menu_bar_keyboard_toggled_cb_gtk_check_menu_item_toggled, self, 0);
#line 385 "menubar.vala"
	_tmp10_ = self->priv->onscreen_keyboard_item;
#line 385 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 386 "menubar.vala"
	_tmp11_ = gtk_menu_item_get_submenu (a11y_item);
#line 386 "menubar.vala"
	_tmp12_ = _tmp11_;
#line 386 "menubar.vala"
	submenu = _tmp12_;
#line 387 "menubar.vala"
	_tmp13_ = self->priv->onscreen_keyboard_item;
#line 387 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) submenu, (GtkMenuItem*) _tmp13_);
#line 388 "menubar.vala"
	_tmp14_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("High Contrast"));
#line 388 "menubar.vala"
	g_object_ref_sink (_tmp14_);
#line 388 "menubar.vala"
	_g_object_unref0 (self->priv->high_contrast_item);
#line 388 "menubar.vala"
	self->priv->high_contrast_item = _tmp14_;
#line 389 "menubar.vala"
	_tmp15_ = self->priv->high_contrast_item;
#line 389 "menubar.vala"
	g_signal_connect_object (_tmp15_, "toggled", (GCallback) _menu_bar_high_contrast_toggled_cb_gtk_check_menu_item_toggled, self, 0);
#line 390 "menubar.vala"
	_tmp16_ = self->priv->high_contrast_item;
#line 390 "menubar.vala"
	_tmp17_ = self->priv->_accel_group;
#line 390 "menubar.vala"
	gtk_widget_add_accelerator ((GtkWidget*) _tmp16_, "activate", _tmp17_, GDK_KEY_h, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
#line 391 "menubar.vala"
	_tmp18_ = self->priv->high_contrast_item;
#line 391 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp18_);
#line 392 "menubar.vala"
	_tmp19_ = self->priv->high_contrast_item;
#line 392 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) submenu, (GtkMenuItem*) _tmp19_);
#line 393 "menubar.vala"
	_tmp20_ = self->priv->high_contrast_item;
#line 393 "menubar.vala"
	gtk_check_menu_item_set_active (_tmp20_, ug_settings_get_boolean (UG_SETTINGS_KEY_HIGH_CONTRAST));
#line 394 "menubar.vala"
	_tmp21_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Screen Reader"));
#line 394 "menubar.vala"
	g_object_ref_sink (_tmp21_);
#line 394 "menubar.vala"
	item = _tmp21_;
#line 395 "menubar.vala"
	g_signal_connect_object (item, "toggled", (GCallback) _menu_bar_screen_reader_toggled_cb_gtk_check_menu_item_toggled, self, 0);
#line 396 "menubar.vala"
	_tmp22_ = self->priv->_accel_group;
#line 396 "menubar.vala"
	gtk_widget_add_accelerator ((GtkWidget*) item, "activate", _tmp22_, GDK_KEY_s, GDK_SUPER_MASK | GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
#line 397 "menubar.vala"
	gtk_widget_show ((GtkWidget*) item);
#line 398 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) submenu, (GtkMenuItem*) item);
#line 399 "menubar.vala"
	gtk_check_menu_item_set_active (item, ug_settings_get_boolean (UG_SETTINGS_KEY_SCREEN_READER));
#line 400 "menubar.vala"
	result = a11y_item;
#line 400 "menubar.vala"
	_g_object_unref0 (item);
#line 400 "menubar.vala"
	_g_object_unref0 (image);
#line 400 "menubar.vala"
	_g_object_unref0 (hbox);
#line 400 "menubar.vala"
	return result;
#line 3906 "menubar.c"
}

static void
___lambda6_ (MenuBar* self)
{
	GError* _inner_error0_ = NULL;
	{
#line 426 "menubar.vala"
		lightdm_suspend (&_inner_error0_);
#line 426 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3918 "menubar.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 424 "menubar.vala"
		e = _inner_error0_;
#line 424 "menubar.vala"
		_inner_error0_ = NULL;
#line 430 "menubar.vala"
		_tmp0_ = e;
#line 430 "menubar.vala"
		_tmp1_ = _tmp0_->message;
#line 430 "menubar.vala"
		g_warning ("menubar.vala:430: Failed to suspend: %s", _tmp1_);
#line 424 "menubar.vala"
		_g_error_free0 (e);
#line 3940 "menubar.c"
	}
	__finally0:
#line 424 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 424 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 424 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 424 "menubar.vala"
		return;
#line 3951 "menubar.c"
	}
}

static void
____lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 422 "menubar.vala"
	___lambda6_ ((MenuBar*) self);
#line 3961 "menubar.c"
}

static void
___lambda7_ (MenuBar* self)
{
	GError* _inner_error0_ = NULL;
	{
#line 444 "menubar.vala"
		lightdm_hibernate (&_inner_error0_);
#line 444 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3973 "menubar.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 442 "menubar.vala"
		e = _inner_error0_;
#line 442 "menubar.vala"
		_inner_error0_ = NULL;
#line 448 "menubar.vala"
		_tmp0_ = e;
#line 448 "menubar.vala"
		_tmp1_ = _tmp0_->message;
#line 448 "menubar.vala"
		g_warning ("menubar.vala:448: Failed to hibernate: %s", _tmp1_);
#line 442 "menubar.vala"
		_g_error_free0 (e);
#line 3995 "menubar.c"
	}
	__finally0:
#line 442 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 442 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 442 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 442 "menubar.vala"
		return;
#line 4006 "menubar.c"
	}
}

static void
____lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 440 "menubar.vala"
	___lambda7_ ((MenuBar*) self);
#line 4016 "menubar.c"
}

static void
_menu_bar_shutdown_cb_gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self)
{
#line 454 "menubar.vala"
	menu_bar_shutdown_cb ((MenuBar*) self, _sender);
#line 4025 "menubar.c"
}

static GtkMenuItem*
menu_bar_make_session_item (MenuBar* self)
{
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkMenuItem* _tmp4_;
	GtkBox* _tmp5_;
	GtkImage* image = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkBox* _tmp11_;
	GtkImage* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenu* _tmp16_;
	GtkMenu* submenu = NULL;
	GtkMenuItem* _tmp17_;
	GtkMenu* _tmp18_;
	GtkMenu* _tmp19_;
	GtkMenuItem* menu_item = NULL;
	GtkMenuItem* _tmp30_;
	GtkMenu* _tmp31_;
	GtkMenuItem* result;
#line 403 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 405 "menubar.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 405 "menubar.vala"
	g_object_ref_sink (_tmp0_);
#line 405 "menubar.vala"
	item = _tmp0_;
#line 406 "menubar.vala"
	_tmp1_ = item;
#line 406 "menubar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, _ ("Quit..."));
#line 407 "menubar.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 407 "menubar.vala"
	g_object_ref_sink (_tmp2_);
#line 407 "menubar.vala"
	hbox = _tmp2_;
#line 408 "menubar.vala"
	_tmp3_ = hbox;
#line 408 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp3_);
#line 409 "menubar.vala"
	_tmp4_ = item;
#line 409 "menubar.vala"
	_tmp5_ = hbox;
#line 409 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 410 "menubar.vala"
	_tmp6_ = g_build_filename (PKGDATADIR, "shutdown.svg", NULL);
#line 410 "menubar.vala"
	_tmp7_ = _tmp6_;
#line 410 "menubar.vala"
	_tmp8_ = (GtkImage*) gtk_image_new_from_file (_tmp7_);
#line 410 "menubar.vala"
	g_object_ref_sink (_tmp8_);
#line 410 "menubar.vala"
	_tmp9_ = _tmp8_;
#line 410 "menubar.vala"
	_g_free0 (_tmp7_);
#line 410 "menubar.vala"
	image = _tmp9_;
#line 411 "menubar.vala"
	_tmp10_ = image;
#line 411 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 412 "menubar.vala"
	_tmp11_ = hbox;
#line 412 "menubar.vala"
	_tmp12_ = image;
#line 412 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
#line 413 "menubar.vala"
	_tmp13_ = item;
#line 413 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp13_);
#line 414 "menubar.vala"
	_tmp14_ = item;
#line 414 "menubar.vala"
	_tmp15_ = (GtkMenu*) gtk_menu_new ();
#line 414 "menubar.vala"
	g_object_ref_sink (_tmp15_);
#line 414 "menubar.vala"
	_tmp16_ = _tmp15_;
#line 414 "menubar.vala"
	gtk_menu_item_set_submenu (_tmp14_, _tmp16_);
#line 414 "menubar.vala"
	_g_object_unref0 (_tmp16_);
#line 415 "menubar.vala"
	_tmp17_ = item;
#line 415 "menubar.vala"
	_tmp18_ = gtk_menu_item_get_submenu (_tmp17_);
#line 415 "menubar.vala"
	_tmp19_ = _tmp18_;
#line 415 "menubar.vala"
	submenu = _tmp19_;
#line 417 "menubar.vala"
	if (lightdm_get_can_suspend ()) {
#line 4137 "menubar.c"
		GtkMenuItem* menu_item = NULL;
		GtkMenuItem* _tmp20_;
		GtkMenuItem* _tmp21_;
		GtkMenu* _tmp22_;
		GtkMenuItem* _tmp23_;
		GtkMenuItem* _tmp24_;
#line 419 "menubar.vala"
		_tmp20_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Suspend"));
#line 419 "menubar.vala"
		g_object_ref_sink (_tmp20_);
#line 419 "menubar.vala"
		menu_item = _tmp20_;
#line 420 "menubar.vala"
		_tmp21_ = menu_item;
#line 420 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp21_);
#line 421 "menubar.vala"
		_tmp22_ = submenu;
#line 421 "menubar.vala"
		_tmp23_ = menu_item;
#line 421 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp22_, _tmp23_);
#line 422 "menubar.vala"
		_tmp24_ = menu_item;
#line 422 "menubar.vala"
		g_signal_connect_object (_tmp24_, "activate", (GCallback) ____lambda6__gtk_menu_item_activate, self, 0);
#line 417 "menubar.vala"
		_g_object_unref0 (menu_item);
#line 4166 "menubar.c"
	}
#line 435 "menubar.vala"
	if (lightdm_get_can_hibernate ()) {
#line 4170 "menubar.c"
		GtkMenuItem* menu_item = NULL;
		GtkMenuItem* _tmp25_;
		GtkMenuItem* _tmp26_;
		GtkMenu* _tmp27_;
		GtkMenuItem* _tmp28_;
		GtkMenuItem* _tmp29_;
#line 437 "menubar.vala"
		_tmp25_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Hibernate"));
#line 437 "menubar.vala"
		g_object_ref_sink (_tmp25_);
#line 437 "menubar.vala"
		menu_item = _tmp25_;
#line 438 "menubar.vala"
		_tmp26_ = menu_item;
#line 438 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp26_);
#line 439 "menubar.vala"
		_tmp27_ = submenu;
#line 439 "menubar.vala"
		_tmp28_ = menu_item;
#line 439 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp27_, _tmp28_);
#line 440 "menubar.vala"
		_tmp29_ = menu_item;
#line 440 "menubar.vala"
		g_signal_connect_object (_tmp29_, "activate", (GCallback) ____lambda7__gtk_menu_item_activate, self, 0);
#line 435 "menubar.vala"
		_g_object_unref0 (menu_item);
#line 4199 "menubar.c"
	}
#line 453 "menubar.vala"
	_tmp30_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Quit..."));
#line 453 "menubar.vala"
	g_object_ref_sink (_tmp30_);
#line 453 "menubar.vala"
	menu_item = _tmp30_;
#line 454 "menubar.vala"
	g_signal_connect_object (menu_item, "activate", (GCallback) _menu_bar_shutdown_cb_gtk_menu_item_activate, self, 0);
#line 455 "menubar.vala"
	gtk_widget_show ((GtkWidget*) menu_item);
#line 456 "menubar.vala"
	_tmp31_ = submenu;
#line 456 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp31_, menu_item);
#line 458 "menubar.vala"
	result = item;
#line 458 "menubar.vala"
	_g_object_unref0 (menu_item);
#line 458 "menubar.vala"
	_g_object_unref0 (image);
#line 458 "menubar.vala"
	_g_object_unref0 (hbox);
#line 458 "menubar.vala"
	return result;
#line 4225 "menubar.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 461 "menubar.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 461 "menubar.vala"
	return _data2_;
#line 4235 "menubar.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 461 "menubar.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 4245 "menubar.c"
		MenuBar* self;
#line 461 "menubar.vala"
		self = _data2_->self;
#line 461 "menubar.vala"
		_g_object_unref0 (_data2_->xapp_controller);
#line 461 "menubar.vala"
		_g_object_unref0 (_data2_->label);
#line 461 "menubar.vala"
		_g_object_unref0 (_data2_->item);
#line 461 "menubar.vala"
		_g_object_unref0 (self);
#line 461 "menubar.vala"
		g_slice_free (Block2Data, _data2_);
#line 4259 "menubar.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 4279 "menubar.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 4301 "menubar.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 4305 "menubar.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 4311 "menubar.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 4315 "menubar.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 4319 "menubar.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 4327 "menubar.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4355 "menubar.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 4364 "menubar.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4378 "menubar.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 4387 "menubar.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 4401 "menubar.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 4410 "menubar.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 4419 "menubar.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 4440 "menubar.c"
}

static void
_g_free0_ (gpointer var)
{
#line 491 "menubar.vala"
	var = (g_free (var), NULL);
#line 4448 "menubar.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 491 "menubar.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 4456 "menubar.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 514 "menubar.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 514 "menubar.vala"
	return _data3_;
#line 4466 "menubar.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 514 "menubar.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 4476 "menubar.c"
		MenuBar* self;
#line 514 "menubar.vala"
		self = _data3_->_data2_->self;
#line 514 "menubar.vala"
		_g_object_unref0 (_data3_->layout);
#line 514 "menubar.vala"
		block2_data_unref (_data3_->_data2_);
#line 514 "menubar.vala"
		_data3_->_data2_ = NULL;
#line 514 "menubar.vala"
		g_slice_free (Block3Data, _data3_);
#line 4488 "menubar.c"
	}
}

static void
____lambda21_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	MenuBar* self;
	LightDMLayout* _tmp0_;
	GtkLabel* _tmp1_;
	LightDMLayout* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkMenuItem* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	LightDMLayout* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
#line 516 "menubar.vala"
	_data2_ = _data3_->_data2_;
#line 516 "menubar.vala"
	self = _data2_->self;
#line 518 "menubar.vala"
	_tmp0_ = _data3_->layout;
#line 518 "menubar.vala"
	lightdm_set_layout (_tmp0_);
#line 519 "menubar.vala"
	_tmp1_ = _data2_->label;
#line 519 "menubar.vala"
	_tmp2_ = _data3_->layout;
#line 519 "menubar.vala"
	_tmp3_ = lightdm_layout_get_name (_tmp2_);
#line 519 "menubar.vala"
	_tmp4_ = _tmp3_;
#line 519 "menubar.vala"
	gtk_label_set_label (_tmp1_, _tmp4_);
#line 520 "menubar.vala"
	_tmp5_ = _data2_->item;
#line 520 "menubar.vala"
	_tmp6_ = g_strconcat (_ ("Keyboard layout:"), " ", NULL);
#line 520 "menubar.vala"
	_tmp7_ = _tmp6_;
#line 520 "menubar.vala"
	_tmp8_ = _data3_->layout;
#line 520 "menubar.vala"
	_tmp9_ = lightdm_layout_get_description (_tmp8_);
#line 520 "menubar.vala"
	_tmp10_ = _tmp9_;
#line 520 "menubar.vala"
	_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
#line 520 "menubar.vala"
	_tmp12_ = _tmp11_;
#line 520 "menubar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp5_, _tmp12_);
#line 520 "menubar.vala"
	_g_free0 (_tmp12_);
#line 520 "menubar.vala"
	_g_free0 (_tmp7_);
#line 4550 "menubar.c"
}

static void
_____lambda21__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 516 "menubar.vala"
	____lambda21_ (self);
#line 4559 "menubar.c"
}

static void
__lambda22_ (Block2Data* _data2_)
{
	MenuBar* self;
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkMenuItem* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 541 "menubar.vala"
	self = _data2_->self;
#line 543 "menubar.vala"
	_tmp0_ = _data2_->label;
#line 543 "menubar.vala"
	_tmp1_ = xapp_kbd_layout_controller_get_current_short_group_label (_data2_->xapp_controller);
#line 543 "menubar.vala"
	_tmp2_ = _tmp1_;
#line 543 "menubar.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 543 "menubar.vala"
	_g_free0 (_tmp2_);
#line 544 "menubar.vala"
	_tmp3_ = _data2_->item;
#line 544 "menubar.vala"
	_tmp4_ = g_strconcat (_ ("Keyboard layout:"), " ", NULL);
#line 544 "menubar.vala"
	_tmp5_ = _tmp4_;
#line 544 "menubar.vala"
	_tmp6_ = xapp_kbd_layout_controller_get_current_name (_data2_->xapp_controller);
#line 544 "menubar.vala"
	_tmp7_ = _tmp6_;
#line 544 "menubar.vala"
	_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 544 "menubar.vala"
	_tmp9_ = _tmp8_;
#line 544 "menubar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _tmp9_);
#line 544 "menubar.vala"
	_g_free0 (_tmp9_);
#line 544 "menubar.vala"
	_g_free0 (_tmp7_);
#line 544 "menubar.vala"
	_g_free0 (_tmp5_);
#line 4610 "menubar.c"
}

static void
___lambda22__gdk_keymap_state_changed (GdkKeymap* _sender,
                                       gpointer self)
{
#line 541 "menubar.vala"
	__lambda22_ (self);
#line 4619 "menubar.c"
}

static GtkMenuItem*
menu_bar_make_keyboard_item (MenuBar* self)
{
	Block2Data* _data2_;
	GtkMenuItem* _tmp0_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkMenuItem* _tmp3_;
	GtkBox* _tmp4_;
	GtkImage* image = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkBox* _tmp10_;
	GtkImage* _tmp11_;
	GtkBox* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	LightDMLayout* current_layout = NULL;
	LightDMLayout* _tmp15_;
	LightDMLayout* _tmp16_;
	LightDMLayout* _tmp17_;
	GdkRGBA keyboard_fg = {0};
	GtkLabel* _tmp30_;
	GtkStyleContext* _tmp31_;
	GdkRGBA _tmp32_ = {0};
	GtkLabel* _tmp33_;
	GdkRGBA _tmp34_;
	GtkLabel* _tmp35_;
	GtkBox* _tmp36_;
	GtkLabel* _tmp37_;
	GtkMenuItem* _tmp38_;
	GtkMenu* system_menu = NULL;
	GtkMenu* _tmp39_;
	GtkMenu* all_menu = NULL;
	GtkMenu* _tmp40_;
	GList* default_layouts = NULL;
	GFile* file = NULL;
	GFile* _tmp41_;
	GFile* _tmp42_;
	GList* _tmp75_;
	GtkMenuItem* _tmp108_;
	GtkMenu* _tmp109_;
	GtkMenuItem* menu_item = NULL;
	GtkMenuItem* _tmp110_;
	GtkMenu* _tmp111_;
	GtkMenu* _tmp112_;
	XAppKbdLayoutController* _tmp113_;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp114_;
	GdkDisplay* _tmp115_;
	GdkKeymap* keymap = NULL;
	GdkKeymap* _tmp116_;
	GdkKeymap* _tmp117_;
	GtkMenuItem* _tmp118_;
	GtkMenuItem* _tmp119_;
	GError* _inner_error0_ = NULL;
	GtkMenuItem* result;
#line 461 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "menubar.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 461 "menubar.vala"
	_data2_->_ref_count_ = 1;
#line 461 "menubar.vala"
	_data2_->self = g_object_ref (self);
#line 463 "menubar.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 463 "menubar.vala"
	g_object_ref_sink (_tmp0_);
#line 463 "menubar.vala"
	_data2_->item = _tmp0_;
#line 464 "menubar.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 464 "menubar.vala"
	g_object_ref_sink (_tmp1_);
#line 464 "menubar.vala"
	hbox = _tmp1_;
#line 465 "menubar.vala"
	_tmp2_ = hbox;
#line 465 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp2_);
#line 466 "menubar.vala"
	_tmp3_ = _data2_->item;
#line 466 "menubar.vala"
	_tmp4_ = hbox;
#line 466 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 467 "menubar.vala"
	_tmp5_ = g_build_filename (PKGDATADIR, "keyboard.svg", NULL);
#line 467 "menubar.vala"
	_tmp6_ = _tmp5_;
#line 467 "menubar.vala"
	_tmp7_ = (GtkImage*) gtk_image_new_from_file (_tmp6_);
#line 467 "menubar.vala"
	g_object_ref_sink (_tmp7_);
#line 467 "menubar.vala"
	_tmp8_ = _tmp7_;
#line 467 "menubar.vala"
	_g_free0 (_tmp6_);
#line 467 "menubar.vala"
	image = _tmp8_;
#line 468 "menubar.vala"
	_tmp9_ = image;
#line 468 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp9_);
#line 469 "menubar.vala"
	_tmp10_ = hbox;
#line 469 "menubar.vala"
	_tmp11_ = image;
#line 469 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
#line 470 "menubar.vala"
	_tmp12_ = hbox;
#line 470 "menubar.vala"
	gtk_box_set_spacing (_tmp12_, 6);
#line 471 "menubar.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new ("");
#line 471 "menubar.vala"
	g_object_ref_sink (_tmp13_);
#line 471 "menubar.vala"
	_data2_->label = _tmp13_;
#line 472 "menubar.vala"
	_tmp14_ = _data2_->label;
#line 472 "menubar.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
#line 473 "menubar.vala"
	_tmp15_ = lightdm_get_layout ();
#line 473 "menubar.vala"
	_tmp16_ = _g_object_ref0 (_tmp15_);
#line 473 "menubar.vala"
	current_layout = _tmp16_;
#line 474 "menubar.vala"
	_tmp17_ = current_layout;
#line 474 "menubar.vala"
	if (_tmp17_ != NULL) {
#line 4761 "menubar.c"
		GtkLabel* _tmp18_;
		LightDMLayout* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GtkMenuItem* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		LightDMLayout* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 475 "menubar.vala"
		_tmp18_ = _data2_->label;
#line 475 "menubar.vala"
		_tmp19_ = current_layout;
#line 475 "menubar.vala"
		_tmp20_ = lightdm_layout_get_name (_tmp19_);
#line 475 "menubar.vala"
		_tmp21_ = _tmp20_;
#line 475 "menubar.vala"
		gtk_label_set_label (_tmp18_, _tmp21_);
#line 476 "menubar.vala"
		_tmp22_ = _data2_->item;
#line 476 "menubar.vala"
		_tmp23_ = g_strconcat (_ ("Keyboard layout:"), " ", NULL);
#line 476 "menubar.vala"
		_tmp24_ = _tmp23_;
#line 476 "menubar.vala"
		_tmp25_ = current_layout;
#line 476 "menubar.vala"
		_tmp26_ = lightdm_layout_get_description (_tmp25_);
#line 476 "menubar.vala"
		_tmp27_ = _tmp26_;
#line 476 "menubar.vala"
		_tmp28_ = g_strconcat (_tmp24_, _tmp27_, NULL);
#line 476 "menubar.vala"
		_tmp29_ = _tmp28_;
#line 476 "menubar.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp22_, _tmp29_);
#line 476 "menubar.vala"
		_g_free0 (_tmp29_);
#line 476 "menubar.vala"
		_g_free0 (_tmp24_);
#line 4806 "menubar.c"
	}
#line 478 "menubar.vala"
	_tmp30_ = _data2_->label;
#line 478 "menubar.vala"
	_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
#line 478 "menubar.vala"
	gtk_style_context_get_color (_tmp31_, GTK_STATE_FLAG_NORMAL, &_tmp32_);
#line 478 "menubar.vala"
	keyboard_fg = _tmp32_;
#line 479 "menubar.vala"
	_tmp33_ = _data2_->label;
#line 479 "menubar.vala"
	_tmp34_ = keyboard_fg;
#line 479 "menubar.vala"
	gtk_widget_override_color ((GtkWidget*) _tmp33_, GTK_STATE_FLAG_INSENSITIVE, &_tmp34_);
#line 480 "menubar.vala"
	_tmp35_ = _data2_->label;
#line 480 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp35_);
#line 481 "menubar.vala"
	_tmp36_ = hbox;
#line 481 "menubar.vala"
	_tmp37_ = _data2_->label;
#line 481 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 482 "menubar.vala"
	_tmp38_ = _data2_->item;
#line 482 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp38_);
#line 484 "menubar.vala"
	_tmp39_ = (GtkMenu*) gtk_menu_new ();
#line 484 "menubar.vala"
	g_object_ref_sink (_tmp39_);
#line 484 "menubar.vala"
	system_menu = _tmp39_;
#line 485 "menubar.vala"
	_tmp40_ = (GtkMenu*) gtk_menu_new ();
#line 485 "menubar.vala"
	g_object_ref_sink (_tmp40_);
#line 485 "menubar.vala"
	all_menu = _tmp40_;
#line 488 "menubar.vala"
	default_layouts = NULL;
#line 489 "menubar.vala"
	_tmp41_ = g_file_new_for_path ("/etc/default/keyboard");
#line 489 "menubar.vala"
	file = _tmp41_;
#line 490 "menubar.vala"
	_tmp42_ = file;
#line 490 "menubar.vala"
	if (g_file_query_exists (_tmp42_, NULL)) {
#line 4858 "menubar.c"
		{
			GFileInputStream* _tmp43_ = NULL;
			GFile* _tmp44_;
			GFileInputStream* _tmp45_;
			GDataInputStream* dis = NULL;
			GDataInputStream* _tmp46_;
			gchar* line = NULL;
#line 492 "menubar.vala"
			_tmp44_ = file;
#line 492 "menubar.vala"
			_tmp45_ = g_file_read (_tmp44_, NULL, &_inner_error0_);
#line 492 "menubar.vala"
			_tmp43_ = _tmp45_;
#line 492 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4874 "menubar.c"
				goto __catch0_g_error;
			}
#line 492 "menubar.vala"
			_tmp46_ = g_data_input_stream_new ((GInputStream*) _tmp43_);
#line 492 "menubar.vala"
			dis = _tmp46_;
#line 494 "menubar.vala"
			while (TRUE) {
#line 4883 "menubar.c"
				gchar* _tmp47_ = NULL;
				GDataInputStream* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				const gchar* _tmp51_;
				const gchar* _tmp52_;
#line 494 "menubar.vala"
				_tmp48_ = dis;
#line 494 "menubar.vala"
				_tmp49_ = g_data_input_stream_read_line (_tmp48_, NULL, NULL, &_inner_error0_);
#line 494 "menubar.vala"
				_tmp47_ = _tmp49_;
#line 494 "menubar.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 494 "menubar.vala"
					_g_free0 (line);
#line 494 "menubar.vala"
					_g_object_unref0 (dis);
#line 494 "menubar.vala"
					_g_object_unref0 (_tmp43_);
#line 4904 "menubar.c"
					goto __catch0_g_error;
				}
#line 494 "menubar.vala"
				_tmp50_ = _tmp47_;
#line 494 "menubar.vala"
				_tmp47_ = NULL;
#line 494 "menubar.vala"
				_g_free0 (line);
#line 494 "menubar.vala"
				line = _tmp50_;
#line 494 "menubar.vala"
				_tmp51_ = line;
#line 494 "menubar.vala"
				if (!(_tmp51_ != NULL)) {
#line 494 "menubar.vala"
					_g_free0 (_tmp47_);
#line 494 "menubar.vala"
					break;
#line 4923 "menubar.c"
				}
#line 495 "menubar.vala"
				_tmp52_ = line;
#line 495 "menubar.vala"
				if (string_contains (_tmp52_, "XKBLAYOUT")) {
#line 4929 "menubar.c"
					gchar* line_layouts = NULL;
					const gchar* _tmp53_;
					gchar** _tmp54_;
					gchar** _tmp55_;
					gchar** _tmp56_;
					gint _tmp56__length1;
					const gchar* _tmp57_;
					gchar* _tmp58_;
					gchar* _tmp59_;
					const gchar* _tmp60_;
					gchar* _tmp61_;
					const gchar* _tmp62_;
					gchar* _tmp63_;
					const gchar* _tmp64_;
#line 496 "menubar.vala"
					_tmp53_ = line;
#line 496 "menubar.vala"
					_tmp55_ = _tmp54_ = g_strsplit (_tmp53_, "=", 0);
#line 496 "menubar.vala"
					_tmp56_ = _tmp55_;
#line 496 "menubar.vala"
					_tmp56__length1 = _vala_array_length (_tmp54_);
#line 496 "menubar.vala"
					_tmp57_ = _tmp56_[1];
#line 496 "menubar.vala"
					_tmp58_ = g_strdup (_tmp57_);
#line 496 "menubar.vala"
					_tmp59_ = _tmp58_;
#line 496 "menubar.vala"
					_tmp56_ = (_vala_array_free (_tmp56_, _tmp56__length1, (GDestroyNotify) g_free), NULL);
#line 496 "menubar.vala"
					line_layouts = _tmp59_;
#line 497 "menubar.vala"
					_tmp60_ = line_layouts;
#line 497 "menubar.vala"
					_tmp61_ = string_replace (_tmp60_, "'", "");
#line 497 "menubar.vala"
					_g_free0 (line_layouts);
#line 497 "menubar.vala"
					line_layouts = _tmp61_;
#line 498 "menubar.vala"
					_tmp62_ = line_layouts;
#line 498 "menubar.vala"
					_tmp63_ = string_replace (_tmp62_, "\"", "");
#line 498 "menubar.vala"
					_g_free0 (line_layouts);
#line 498 "menubar.vala"
					line_layouts = _tmp63_;
#line 499 "menubar.vala"
					_tmp64_ = line_layouts;
#line 499 "menubar.vala"
					if (string_contains (_tmp64_, ",")) {
#line 4982 "menubar.c"
						const gchar* _tmp65_;
						gchar** _tmp66_;
						gchar** _tmp67_;
#line 500 "menubar.vala"
						_tmp65_ = line_layouts;
#line 500 "menubar.vala"
						_tmp67_ = _tmp66_ = g_strsplit (_tmp65_, ",", 0);
#line 4990 "menubar.c"
						{
							gchar** element_collection = NULL;
							gint element_collection_length1 = 0;
							gint _element_collection_size_ = 0;
							gint element_it = 0;
#line 500 "menubar.vala"
							element_collection = _tmp67_;
#line 500 "menubar.vala"
							element_collection_length1 = _vala_array_length (_tmp66_);
#line 500 "menubar.vala"
							for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
#line 5002 "menubar.c"
								gchar* _tmp68_;
								gchar* element = NULL;
#line 500 "menubar.vala"
								_tmp68_ = g_strdup (element_collection[element_it]);
#line 500 "menubar.vala"
								element = _tmp68_;
#line 5009 "menubar.c"
								{
									const gchar* _tmp69_;
									gchar* _tmp70_;
									const gchar* _tmp71_;
									gchar* _tmp72_;
#line 501 "menubar.vala"
									_tmp69_ = element;
#line 501 "menubar.vala"
									_tmp70_ = string_strip (_tmp69_);
#line 501 "menubar.vala"
									_g_free0 (element);
#line 501 "menubar.vala"
									element = _tmp70_;
#line 502 "menubar.vala"
									_tmp71_ = element;
#line 502 "menubar.vala"
									_tmp72_ = g_strdup (_tmp71_);
#line 502 "menubar.vala"
									default_layouts = g_list_append (default_layouts, _tmp72_);
#line 500 "menubar.vala"
									_g_free0 (element);
#line 5031 "menubar.c"
								}
							}
#line 500 "menubar.vala"
							element_collection = (_vala_array_free (element_collection, element_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5036 "menubar.c"
						}
					}
#line 505 "menubar.vala"
					_g_free0 (line_layouts);
#line 505 "menubar.vala"
					_g_free0 (_tmp47_);
#line 505 "menubar.vala"
					break;
#line 5045 "menubar.c"
				}
#line 494 "menubar.vala"
				_g_free0 (_tmp47_);
#line 5049 "menubar.c"
			}
#line 491 "menubar.vala"
			_g_free0 (line);
#line 491 "menubar.vala"
			_g_object_unref0 (dis);
#line 491 "menubar.vala"
			_g_object_unref0 (_tmp43_);
#line 5057 "menubar.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp73_;
			const gchar* _tmp74_;
#line 491 "menubar.vala"
			e = _inner_error0_;
#line 491 "menubar.vala"
			_inner_error0_ = NULL;
#line 509 "menubar.vala"
			_tmp73_ = e;
#line 509 "menubar.vala"
			_tmp74_ = _tmp73_->message;
#line 509 "menubar.vala"
			g_warning ("menubar.vala:509: %s", _tmp74_);
#line 491 "menubar.vala"
			_g_error_free0 (e);
#line 5077 "menubar.c"
		}
		__finally0:
#line 491 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 491 "menubar.vala"
			_g_object_unref0 (file);
#line 491 "menubar.vala"
			(default_layouts == NULL) ? NULL : (default_layouts = (_g_list_free__g_free0_ (default_layouts), NULL));
#line 491 "menubar.vala"
			_g_object_unref0 (all_menu);
#line 491 "menubar.vala"
			_g_object_unref0 (system_menu);
#line 491 "menubar.vala"
			_g_object_unref0 (current_layout);
#line 491 "menubar.vala"
			_g_object_unref0 (image);
#line 491 "menubar.vala"
			_g_object_unref0 (hbox);
#line 491 "menubar.vala"
			block2_data_unref (_data2_);
#line 491 "menubar.vala"
			_data2_ = NULL;
#line 491 "menubar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 491 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 491 "menubar.vala"
			return NULL;
#line 5106 "menubar.c"
		}
	}
#line 514 "menubar.vala"
	_tmp75_ = lightdm_get_layouts ();
#line 5111 "menubar.c"
	{
		GList* layout_collection = NULL;
		GList* layout_it = NULL;
#line 514 "menubar.vala"
		layout_collection = _tmp75_;
#line 514 "menubar.vala"
		for (layout_it = layout_collection; layout_it != NULL; layout_it = layout_it->next) {
#line 5119 "menubar.c"
			LightDMLayout* _tmp76_;
			LightDMLayout* layout = NULL;
#line 514 "menubar.vala"
			_tmp76_ = _g_object_ref0 ((LightDMLayout*) layout_it->data);
#line 514 "menubar.vala"
			layout = _tmp76_;
#line 5126 "menubar.c"
			{
				Block3Data* _data3_;
				GtkMenuItem* menu_item = NULL;
				LightDMLayout* _tmp77_;
				const gchar* _tmp78_;
				const gchar* _tmp79_;
				gchar* _tmp80_;
				gchar* _tmp81_;
				LightDMLayout* _tmp82_;
				const gchar* _tmp83_;
				const gchar* _tmp84_;
				gchar* _tmp85_;
				gchar* _tmp86_;
				GtkMenuItem* _tmp87_;
				GtkMenuItem* _tmp88_;
				GtkMenuItem* _tmp89_;
				gboolean _tmp90_ = FALSE;
				LightDMLayout* _tmp91_;
				const gchar* _tmp92_;
				const gchar* _tmp93_;
				LightDMLayout* _tmp94_;
				const gchar* _tmp95_;
				const gchar* _tmp96_;
				GtkMenuItem* _tmp107_;
#line 514 "menubar.vala"
				_data3_ = g_slice_new0 (Block3Data);
#line 514 "menubar.vala"
				_data3_->_ref_count_ = 1;
#line 514 "menubar.vala"
				_data3_->_data2_ = block2_data_ref (_data2_);
#line 514 "menubar.vala"
				_data3_->layout = layout;
#line 515 "menubar.vala"
				_tmp77_ = _data3_->layout;
#line 515 "menubar.vala"
				_tmp78_ = lightdm_layout_get_name (_tmp77_);
#line 515 "menubar.vala"
				_tmp79_ = _tmp78_;
#line 515 "menubar.vala"
				_tmp80_ = g_strconcat (_tmp79_, " - ", NULL);
#line 515 "menubar.vala"
				_tmp81_ = _tmp80_;
#line 515 "menubar.vala"
				_tmp82_ = _data3_->layout;
#line 515 "menubar.vala"
				_tmp83_ = lightdm_layout_get_description (_tmp82_);
#line 515 "menubar.vala"
				_tmp84_ = _tmp83_;
#line 515 "menubar.vala"
				_tmp85_ = g_strconcat (_tmp81_, _tmp84_, NULL);
#line 515 "menubar.vala"
				_tmp86_ = _tmp85_;
#line 515 "menubar.vala"
				_tmp87_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp86_);
#line 515 "menubar.vala"
				g_object_ref_sink (_tmp87_);
#line 515 "menubar.vala"
				_tmp88_ = _tmp87_;
#line 515 "menubar.vala"
				_g_free0 (_tmp86_);
#line 515 "menubar.vala"
				_g_free0 (_tmp81_);
#line 515 "menubar.vala"
				menu_item = _tmp88_;
#line 516 "menubar.vala"
				_tmp89_ = menu_item;
#line 516 "menubar.vala"
				g_signal_connect_data (_tmp89_, "activate", (GCallback) _____lambda21__gtk_menu_item_activate, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 522 "menubar.vala"
				_tmp91_ = _data3_->layout;
#line 522 "menubar.vala"
				_tmp92_ = lightdm_layout_get_name (_tmp91_);
#line 522 "menubar.vala"
				_tmp93_ = _tmp92_;
#line 522 "menubar.vala"
				_tmp94_ = current_layout;
#line 522 "menubar.vala"
				_tmp95_ = lightdm_layout_get_name (_tmp94_);
#line 522 "menubar.vala"
				_tmp96_ = _tmp95_;
#line 522 "menubar.vala"
				if (g_strcmp0 (_tmp93_, _tmp96_) == 0) {
#line 522 "menubar.vala"
					_tmp90_ = TRUE;
#line 5211 "menubar.c"
				} else {
					GList* _tmp97_;
					LightDMLayout* _tmp98_;
					const gchar* _tmp99_;
					const gchar* _tmp100_;
					GCompareFunc _tmp101_;
					GList* _tmp102_;
#line 522 "menubar.vala"
					_tmp97_ = default_layouts;
#line 522 "menubar.vala"
					_tmp98_ = _data3_->layout;
#line 522 "menubar.vala"
					_tmp99_ = lightdm_layout_get_name (_tmp98_);
#line 522 "menubar.vala"
					_tmp100_ = _tmp99_;
#line 522 "menubar.vala"
					_tmp101_ = ((GCompareFunc) g_strcmp0);
#line 522 "menubar.vala"
					_tmp102_ = g_list_find_custom (_tmp97_, _tmp100_, _tmp101_);
#line 522 "menubar.vala"
					_tmp90_ = _tmp102_ != NULL;
#line 5233 "menubar.c"
				}
#line 522 "menubar.vala"
				if (_tmp90_) {
#line 5237 "menubar.c"
					GtkMenu* _tmp103_;
					GtkMenuItem* _tmp104_;
#line 523 "menubar.vala"
					_tmp103_ = system_menu;
#line 523 "menubar.vala"
					_tmp104_ = menu_item;
#line 523 "menubar.vala"
					gtk_menu_shell_append ((GtkMenuShell*) _tmp103_, _tmp104_);
#line 5246 "menubar.c"
				} else {
					GtkMenu* _tmp105_;
					GtkMenuItem* _tmp106_;
#line 526 "menubar.vala"
					_tmp105_ = all_menu;
#line 526 "menubar.vala"
					_tmp106_ = menu_item;
#line 526 "menubar.vala"
					gtk_menu_shell_append ((GtkMenuShell*) _tmp105_, _tmp106_);
#line 5256 "menubar.c"
				}
#line 528 "menubar.vala"
				_tmp107_ = menu_item;
#line 528 "menubar.vala"
				gtk_widget_show ((GtkWidget*) _tmp107_);
#line 514 "menubar.vala"
				_g_object_unref0 (menu_item);
#line 514 "menubar.vala"
				block3_data_unref (_data3_);
#line 514 "menubar.vala"
				_data3_ = NULL;
#line 5268 "menubar.c"
			}
		}
	}
#line 531 "menubar.vala"
	_tmp108_ = _data2_->item;
#line 531 "menubar.vala"
	_tmp109_ = system_menu;
#line 531 "menubar.vala"
	gtk_menu_item_set_submenu (_tmp108_, _tmp109_);
#line 532 "menubar.vala"
	_tmp110_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("More layouts..."));
#line 532 "menubar.vala"
	g_object_ref_sink (_tmp110_);
#line 532 "menubar.vala"
	menu_item = _tmp110_;
#line 533 "menubar.vala"
	_tmp111_ = system_menu;
#line 533 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp111_, menu_item);
#line 534 "menubar.vala"
	_tmp112_ = all_menu;
#line 534 "menubar.vala"
	gtk_menu_item_set_submenu (menu_item, _tmp112_);
#line 535 "menubar.vala"
	gtk_widget_show ((GtkWidget*) menu_item);
#line 538 "menubar.vala"
	_tmp113_ = xapp_kbd_layout_controller_new ();
#line 538 "menubar.vala"
	_data2_->xapp_controller = _tmp113_;
#line 539 "menubar.vala"
	_tmp114_ = gtk_widget_get_display ((GtkWidget*) self);
#line 539 "menubar.vala"
	_tmp115_ = _g_object_ref0 (_tmp114_);
#line 539 "menubar.vala"
	display = _tmp115_;
#line 540 "menubar.vala"
	_tmp116_ = gdk_keymap_get_for_display (display);
#line 540 "menubar.vala"
	_tmp117_ = _g_object_ref0 (_tmp116_);
#line 540 "menubar.vala"
	keymap = _tmp117_;
#line 541 "menubar.vala"
	g_signal_connect_data (keymap, "state-changed", (GCallback) ___lambda22__gdk_keymap_state_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 547 "menubar.vala"
	_tmp118_ = _data2_->item;
#line 547 "menubar.vala"
	_tmp119_ = _g_object_ref0 (_tmp118_);
#line 547 "menubar.vala"
	result = _tmp119_;
#line 547 "menubar.vala"
	_g_object_unref0 (keymap);
#line 547 "menubar.vala"
	_g_object_unref0 (display);
#line 547 "menubar.vala"
	_g_object_unref0 (menu_item);
#line 547 "menubar.vala"
	_g_object_unref0 (file);
#line 547 "menubar.vala"
	(default_layouts == NULL) ? NULL : (default_layouts = (_g_list_free__g_free0_ (default_layouts), NULL));
#line 547 "menubar.vala"
	_g_object_unref0 (all_menu);
#line 547 "menubar.vala"
	_g_object_unref0 (system_menu);
#line 547 "menubar.vala"
	_g_object_unref0 (current_layout);
#line 547 "menubar.vala"
	_g_object_unref0 (image);
#line 547 "menubar.vala"
	_g_object_unref0 (hbox);
#line 547 "menubar.vala"
	block2_data_unref (_data2_);
#line 547 "menubar.vala"
	_data2_ = NULL;
#line 547 "menubar.vala"
	return result;
#line 5344 "menubar.c"
}

static void
menu_bar_shutdown_cb (MenuBar* self,
                      GtkMenuItem* item)
{
	MainWindow* _tmp0_;
#line 550 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 550 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 552 "menubar.vala"
	_tmp0_ = self->priv->_main_window;
#line 552 "menubar.vala"
	if (_tmp0_ != NULL) {
#line 5360 "menubar.c"
		MainWindow* _tmp1_;
#line 553 "menubar.vala"
		_tmp1_ = self->priv->_main_window;
#line 553 "menubar.vala"
		main_window_show_shutdown_dialog (_tmp1_, SHUTDOWN_DIALOG_TYPE_RESTART);
#line 5366 "menubar.c"
	}
}

static void
menu_bar_keyboard_toggled_cb (MenuBar* self,
                              GtkCheckMenuItem* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp47_;
	gboolean _tmp48_;
	gboolean _tmp49_;
	GError* _inner_error0_ = NULL;
#line 557 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 557 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 565 "menubar.vala"
	_tmp0_ = gtk_check_menu_item_get_active (item);
#line 565 "menubar.vala"
	_tmp1_ = _tmp0_;
#line 565 "menubar.vala"
	ug_settings_set_boolean (UG_SETTINGS_KEY_ONSCREEN_KEYBOARD, _tmp1_);
#line 567 "menubar.vala"
	_tmp2_ = self->priv->_keyboard_window;
#line 567 "menubar.vala"
	if (_tmp2_ == NULL) {
#line 5395 "menubar.c"
		gint id = 0;
		GtkSocket* keyboard_socket = NULL;
		GtkSocket* _tmp24_;
		GtkSocket* _tmp25_;
		GtkWindow* _tmp26_;
		GtkWindow* _tmp27_;
		GtkWindow* _tmp28_;
		GtkWindow* _tmp29_;
		GtkWindow* _tmp30_;
		GtkSocket* _tmp31_;
		GtkSocket* _tmp32_;
		GdkDisplay* display = NULL;
		GdkDisplay* _tmp33_;
		GdkDisplay* _tmp34_;
		GdkMonitor* monitor = NULL;
		GdkDisplay* _tmp35_;
		GdkWindow* _tmp36_;
		GdkMonitor* _tmp37_;
		GdkMonitor* _tmp38_;
		GdkRectangle geom = {0};
		GdkMonitor* _tmp39_;
		GdkRectangle _tmp40_ = {0};
		GtkWindow* _tmp41_;
		GdkRectangle _tmp42_;
		GdkRectangle _tmp43_;
		GdkRectangle _tmp44_;
		GtkWindow* _tmp45_;
		GdkRectangle _tmp46_;
#line 569 "menubar.vala"
		id = 0;
#line 5426 "menubar.c"
		{
			gchar** argv = NULL;
			gint argv_length1 = 0;
			gint _argv_size_ = 0;
			gchar* cmd = NULL;
			gint onboard_stdout_fd = 0;
			gchar* layout = NULL;
			gchar* _tmp3_;
			GFile* file = NULL;
			const gchar* _tmp4_;
			GFile* _tmp5_;
			GFile* _tmp6_;
			const gchar* _tmp10_;
			gchar** _tmp11_ = NULL;
			gint _tmp12_ = 0;
			gchar** _tmp13_;
			gint _tmp13__length1;
			GPid _tmp14_ = 0;
			gint _tmp15_ = 0;
			FILE* f = NULL;
			FILE* _tmp16_;
			gchar* stdout_text = NULL;
			gchar* _tmp17_;
			gint stdout_text_length1;
			gint _stdout_text_size_;
			FILE* _tmp18_;
			gchar* _tmp19_;
			gint _tmp19__length1;
			const gchar* _tmp20_;
#line 576 "menubar.vala"
			_tmp3_ = ug_settings_get_string (UG_SETTINGS_KEY_ONSCREEN_KEYBOARD_LAYOUT);
#line 576 "menubar.vala"
			layout = _tmp3_;
#line 577 "menubar.vala"
			_tmp4_ = layout;
#line 577 "menubar.vala"
			_tmp5_ = g_file_new_for_path (_tmp4_);
#line 577 "menubar.vala"
			file = _tmp5_;
#line 578 "menubar.vala"
			_tmp6_ = file;
#line 578 "menubar.vala"
			if (g_file_query_exists (_tmp6_, NULL)) {
#line 5470 "menubar.c"
				const gchar* _tmp7_;
				gchar* _tmp8_;
#line 579 "menubar.vala"
				_tmp7_ = layout;
#line 579 "menubar.vala"
				_tmp8_ = g_strdup_printf ("onboard --xid --layout='%s'", _tmp7_);
#line 579 "menubar.vala"
				_g_free0 (cmd);
#line 579 "menubar.vala"
				cmd = _tmp8_;
#line 5481 "menubar.c"
			} else {
				gchar* _tmp9_;
#line 582 "menubar.vala"
				_tmp9_ = g_strdup ("onboard --xid");
#line 582 "menubar.vala"
				_g_free0 (cmd);
#line 582 "menubar.vala"
				cmd = _tmp9_;
#line 5490 "menubar.c"
			}
#line 584 "menubar.vala"
			_tmp10_ = cmd;
#line 584 "menubar.vala"
			g_shell_parse_argv (_tmp10_, &_tmp12_, &_tmp11_, &_inner_error0_);
#line 584 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 584 "menubar.vala"
			argv = _tmp11_;
#line 584 "menubar.vala"
			argv_length1 = _tmp12_;
#line 584 "menubar.vala"
			_argv_size_ = argv_length1;
#line 584 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 584 "menubar.vala"
				_g_object_unref0 (file);
#line 584 "menubar.vala"
				_g_free0 (layout);
#line 584 "menubar.vala"
				_g_free0 (cmd);
#line 584 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 5514 "menubar.c"
				goto __catch0_g_error;
			}
#line 585 "menubar.vala"
			_tmp13_ = argv;
#line 585 "menubar.vala"
			_tmp13__length1 = argv_length1;
#line 585 "menubar.vala"
			g_spawn_async_with_pipes (NULL, _tmp13_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp14_, NULL, &_tmp15_, NULL, &_inner_error0_);
#line 585 "menubar.vala"
			self->priv->keyboard_pid = _tmp14_;
#line 585 "menubar.vala"
			onboard_stdout_fd = _tmp15_;
#line 585 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 585 "menubar.vala"
				_g_object_unref0 (file);
#line 585 "menubar.vala"
				_g_free0 (layout);
#line 585 "menubar.vala"
				_g_free0 (cmd);
#line 585 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 5537 "menubar.c"
				goto __catch0_g_error;
			}
#line 594 "menubar.vala"
			_tmp16_ = fdopen (onboard_stdout_fd, "r");
#line 594 "menubar.vala"
			f = _tmp16_;
#line 595 "menubar.vala"
			_tmp17_ = g_new0 (gchar, 1024);
#line 595 "menubar.vala"
			stdout_text = _tmp17_;
#line 595 "menubar.vala"
			stdout_text_length1 = 1024;
#line 595 "menubar.vala"
			_stdout_text_size_ = stdout_text_length1;
#line 596 "menubar.vala"
			_tmp18_ = f;
#line 596 "menubar.vala"
			_tmp19_ = stdout_text;
#line 596 "menubar.vala"
			_tmp19__length1 = stdout_text_length1;
#line 596 "menubar.vala"
			_tmp20_ = fgets (_tmp19_, (gint) _tmp19__length1, _tmp18_);
#line 596 "menubar.vala"
			if (_tmp20_ != NULL) {
#line 5562 "menubar.c"
				gchar* _tmp21_;
				gint _tmp21__length1;
#line 597 "menubar.vala"
				_tmp21_ = stdout_text;
#line 597 "menubar.vala"
				_tmp21__length1 = stdout_text_length1;
#line 597 "menubar.vala"
				id = atoi ((const gchar*) _tmp21_);
#line 5571 "menubar.c"
			}
#line 571 "menubar.vala"
			stdout_text = (g_free (stdout_text), NULL);
#line 571 "menubar.vala"
			_fclose0 (f);
#line 571 "menubar.vala"
			_g_object_unref0 (file);
#line 571 "menubar.vala"
			_g_free0 (layout);
#line 571 "menubar.vala"
			_g_free0 (cmd);
#line 571 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 5585 "menubar.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp22_;
			const gchar* _tmp23_;
#line 571 "menubar.vala"
			e = _inner_error0_;
#line 571 "menubar.vala"
			_inner_error0_ = NULL;
#line 602 "menubar.vala"
			_tmp22_ = e;
#line 602 "menubar.vala"
			_tmp23_ = _tmp22_->message;
#line 602 "menubar.vala"
			g_warning ("menubar.vala:602: Error setting up keyboard: %s", _tmp23_);
#line 603 "menubar.vala"
			_g_error_free0 (e);
#line 603 "menubar.vala"
			return;
#line 5607 "menubar.c"
		}
		__finally0:
#line 571 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 571 "menubar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 571 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 571 "menubar.vala"
			return;
#line 5618 "menubar.c"
		}
#line 606 "menubar.vala"
		_tmp24_ = (GtkSocket*) gtk_socket_new ();
#line 606 "menubar.vala"
		g_object_ref_sink (_tmp24_);
#line 606 "menubar.vala"
		keyboard_socket = _tmp24_;
#line 607 "menubar.vala"
		_tmp25_ = keyboard_socket;
#line 607 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp25_);
#line 608 "menubar.vala"
		_tmp26_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL);
#line 608 "menubar.vala"
		g_object_ref_sink (_tmp26_);
#line 608 "menubar.vala"
		_tmp27_ = _tmp26_;
#line 608 "menubar.vala"
		menu_bar_set_keyboard_window (self, _tmp27_);
#line 608 "menubar.vala"
		_g_object_unref0 (_tmp27_);
#line 609 "menubar.vala"
		_tmp28_ = self->priv->_keyboard_window;
#line 609 "menubar.vala"
		gtk_window_set_accept_focus (_tmp28_, FALSE);
#line 610 "menubar.vala"
		_tmp29_ = self->priv->_keyboard_window;
#line 610 "menubar.vala"
		gtk_window_set_focus_on_map (_tmp29_, FALSE);
#line 611 "menubar.vala"
		_tmp30_ = self->priv->_keyboard_window;
#line 611 "menubar.vala"
		_tmp31_ = keyboard_socket;
#line 611 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 612 "menubar.vala"
		_tmp32_ = keyboard_socket;
#line 612 "menubar.vala"
		gtk_socket_add_id (_tmp32_, (Window) id);
#line 615 "menubar.vala"
		_tmp33_ = gtk_widget_get_display ((GtkWidget*) self);
#line 615 "menubar.vala"
		_tmp34_ = _g_object_ref0 (_tmp33_);
#line 615 "menubar.vala"
		display = _tmp34_;
#line 616 "menubar.vala"
		_tmp35_ = display;
#line 616 "menubar.vala"
		_tmp36_ = gtk_widget_get_window ((GtkWidget*) self);
#line 616 "menubar.vala"
		_tmp37_ = gdk_display_get_monitor_at_window (_tmp35_, _tmp36_);
#line 616 "menubar.vala"
		_tmp38_ = _g_object_ref0 (_tmp37_);
#line 616 "menubar.vala"
		monitor = _tmp38_;
#line 618 "menubar.vala"
		_tmp39_ = monitor;
#line 618 "menubar.vala"
		gdk_monitor_get_geometry (_tmp39_, &_tmp40_);
#line 618 "menubar.vala"
		geom = _tmp40_;
#line 619 "menubar.vala"
		_tmp41_ = self->priv->_keyboard_window;
#line 619 "menubar.vala"
		_tmp42_ = geom;
#line 619 "menubar.vala"
		_tmp43_ = geom;
#line 619 "menubar.vala"
		_tmp44_ = geom;
#line 619 "menubar.vala"
		gtk_window_move (_tmp41_, _tmp42_.x, (_tmp43_.y + _tmp44_.height) - 250);
#line 620 "menubar.vala"
		_tmp45_ = self->priv->_keyboard_window;
#line 620 "menubar.vala"
		_tmp46_ = geom;
#line 620 "menubar.vala"
		gtk_window_resize (_tmp45_, _tmp46_.width, 250);
#line 567 "menubar.vala"
		_g_object_unref0 (monitor);
#line 567 "menubar.vala"
		_g_object_unref0 (display);
#line 567 "menubar.vala"
		_g_object_unref0 (keyboard_socket);
#line 5702 "menubar.c"
	}
#line 623 "menubar.vala"
	_tmp47_ = self->priv->_keyboard_window;
#line 623 "menubar.vala"
	_tmp48_ = gtk_check_menu_item_get_active (item);
#line 623 "menubar.vala"
	_tmp49_ = _tmp48_;
#line 623 "menubar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp47_, _tmp49_);
#line 5712 "menubar.c"
}

static void
menu_bar_high_contrast_toggled_cb (MenuBar* self,
                                   GtkCheckMenuItem* item)
{
	GtkSettings* settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 626 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 626 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 628 "menubar.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 628 "menubar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 628 "menubar.vala"
	settings = _tmp1_;
#line 629 "menubar.vala"
	_tmp2_ = gtk_check_menu_item_get_active (item);
#line 629 "menubar.vala"
	_tmp3_ = _tmp2_;
#line 629 "menubar.vala"
	if (_tmp3_) {
#line 5743 "menubar.c"
		GtkSettings* _tmp4_;
#line 630 "menubar.vala"
		_tmp4_ = settings;
#line 630 "menubar.vala"
		g_object_set ((GObject*) _tmp4_, "gtk-theme-name", "HighContrast", NULL);
#line 5749 "menubar.c"
	} else {
		GtkSettings* _tmp5_;
		const gchar* _tmp6_;
#line 632 "menubar.vala"
		_tmp5_ = settings;
#line 632 "menubar.vala"
		_tmp6_ = self->priv->default_theme_name;
#line 632 "menubar.vala"
		g_object_set ((GObject*) _tmp5_, "gtk-theme-name", _tmp6_, NULL);
#line 5759 "menubar.c"
	}
#line 633 "menubar.vala"
	_tmp7_ = gtk_check_menu_item_get_active (item);
#line 633 "menubar.vala"
	_tmp8_ = _tmp7_;
#line 633 "menubar.vala"
	menu_bar_set_high_contrast (self, _tmp8_);
#line 634 "menubar.vala"
	_tmp9_ = self->priv->_high_contrast;
#line 634 "menubar.vala"
	ug_settings_set_boolean (UG_SETTINGS_KEY_HIGH_CONTRAST, _tmp9_);
#line 626 "menubar.vala"
	_g_object_unref0 (settings);
#line 5773 "menubar.c"
}

static gboolean
____lambda5_ (MenuBar* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	AtkObject* _tmp2_;
	gboolean result;
#line 667 "menubar.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 667 "menubar.vala"
	_tmp1_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL);
#line 667 "menubar.vala"
	_tmp2_ = gtk_widget_get_accessible (_tmp1_);
#line 667 "menubar.vala"
	g_signal_emit_by_name (_tmp2_, "focus-event", TRUE, NULL);
#line 668 "menubar.vala"
	result = FALSE;
#line 668 "menubar.vala"
	return result;
#line 5795 "menubar.c"
}

static gboolean
_____lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda5_ ((MenuBar*) self);
#line 666 "menubar.vala"
	return result;
#line 5805 "menubar.c"
}

static void
menu_bar_screen_reader_toggled_cb (MenuBar* self,
                                   GtkCheckMenuItem* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GError* _inner_error0_ = NULL;
#line 637 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 637 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 639 "menubar.vala"
	_tmp0_ = gtk_check_menu_item_get_active (item);
#line 639 "menubar.vala"
	_tmp1_ = _tmp0_;
#line 639 "menubar.vala"
	ug_settings_set_boolean (UG_SETTINGS_KEY_SCREEN_READER, _tmp1_);
#line 641 "menubar.vala"
	_tmp2_ = gtk_check_menu_item_get_active (item);
#line 641 "menubar.vala"
	_tmp3_ = _tmp2_;
#line 641 "menubar.vala"
	if (_tmp3_) {
#line 5833 "menubar.c"
		{
			gchar** argv = NULL;
			gint argv_length1 = 0;
			gint _argv_size_ = 0;
			gchar** _tmp4_ = NULL;
			gint _tmp5_ = 0;
			gchar** _tmp6_;
			gint _tmp6__length1;
			GPid _tmp7_ = 0;
			SlickGreeter* _tmp8_;
#line 646 "menubar.vala"
			g_shell_parse_argv ("orca --replace", &_tmp5_, &_tmp4_, &_inner_error0_);
#line 646 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 646 "menubar.vala"
			argv = _tmp4_;
#line 646 "menubar.vala"
			argv_length1 = _tmp5_;
#line 646 "menubar.vala"
			_argv_size_ = argv_length1;
#line 646 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 646 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 5858 "menubar.c"
				goto __catch0_g_error;
			}
#line 647 "menubar.vala"
			_tmp6_ = argv;
#line 647 "menubar.vala"
			_tmp6__length1 = argv_length1;
#line 647 "menubar.vala"
			g_spawn_async (NULL, _tmp6_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp7_, &_inner_error0_);
#line 647 "menubar.vala"
			self->priv->reader_pid = _tmp7_;
#line 647 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 647 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 5873 "menubar.c"
				goto __catch0_g_error;
			}
#line 665 "menubar.vala"
			_tmp8_ = slick_greeter_singleton;
#line 665 "menubar.vala"
			_tmp8_->orca_needs_kick = TRUE;
#line 666 "menubar.vala"
			g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _____lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 643 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 5884 "menubar.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 643 "menubar.vala"
			e = _inner_error0_;
#line 643 "menubar.vala"
			_inner_error0_ = NULL;
#line 673 "menubar.vala"
			_tmp9_ = e;
#line 673 "menubar.vala"
			_tmp10_ = _tmp9_->message;
#line 673 "menubar.vala"
			g_warning ("menubar.vala:673: Failed to run Orca: %s", _tmp10_);
#line 643 "menubar.vala"
			_g_error_free0 (e);
#line 5904 "menubar.c"
		}
		__finally0:
#line 643 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 643 "menubar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 643 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 643 "menubar.vala"
			return;
#line 5915 "menubar.c"
		}
	} else {
#line 677 "menubar.vala"
		menu_bar_close_pid (self, &self->priv->reader_pid);
#line 5920 "menubar.c"
	}
}

Background*
menu_bar_get_background (MenuBar* self)
{
	Background* result;
	Background* _tmp0_;
#line 80 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 80 "menubar.vala"
	_tmp0_ = self->priv->_background;
#line 80 "menubar.vala"
	result = _tmp0_;
#line 80 "menubar.vala"
	return result;
#line 5937 "menubar.c"
}

static void
menu_bar_set_background (MenuBar* self,
                         Background* value)
{
	Background* old_value;
#line 80 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 80 "menubar.vala"
	old_value = menu_bar_get_background (self);
#line 80 "menubar.vala"
	if (old_value != value) {
#line 5951 "menubar.c"
		Background* _tmp0_;
#line 80 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 80 "menubar.vala"
		_g_object_unref0 (self->priv->_background);
#line 80 "menubar.vala"
		self->priv->_background = _tmp0_;
#line 80 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_BACKGROUND_PROPERTY]);
#line 5961 "menubar.c"
	}
}

gboolean
menu_bar_get_high_contrast (MenuBar* self)
{
	gboolean result;
#line 81 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "menubar.vala"
	result = self->priv->_high_contrast;
#line 81 "menubar.vala"
	return result;
#line 5975 "menubar.c"
}

static void
menu_bar_set_high_contrast (MenuBar* self,
                            gboolean value)
{
	gboolean old_value;
#line 81 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 81 "menubar.vala"
	old_value = menu_bar_get_high_contrast (self);
#line 81 "menubar.vala"
	if (old_value != value) {
#line 81 "menubar.vala"
		self->priv->_high_contrast = value;
#line 81 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_HIGH_CONTRAST_PROPERTY]);
#line 5993 "menubar.c"
	}
}

GtkWindow*
menu_bar_get_keyboard_window (MenuBar* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 82 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "menubar.vala"
	_tmp0_ = self->priv->_keyboard_window;
#line 82 "menubar.vala"
	result = _tmp0_;
#line 82 "menubar.vala"
	return result;
#line 6010 "menubar.c"
}

static void
menu_bar_set_keyboard_window (MenuBar* self,
                              GtkWindow* value)
{
	GtkWindow* old_value;
#line 82 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 82 "menubar.vala"
	old_value = menu_bar_get_keyboard_window (self);
#line 82 "menubar.vala"
	if (old_value != value) {
#line 6024 "menubar.c"
		GtkWindow* _tmp0_;
#line 82 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 82 "menubar.vala"
		_g_object_unref0 (self->priv->_keyboard_window);
#line 82 "menubar.vala"
		self->priv->_keyboard_window = _tmp0_;
#line 82 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_KEYBOARD_WINDOW_PROPERTY]);
#line 6034 "menubar.c"
	}
}

GtkAccelGroup*
menu_bar_get_accel_group (MenuBar* self)
{
	GtkAccelGroup* result;
	GtkAccelGroup* _tmp0_;
#line 83 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "menubar.vala"
	_tmp0_ = self->priv->_accel_group;
#line 83 "menubar.vala"
	result = _tmp0_;
#line 83 "menubar.vala"
	return result;
#line 6051 "menubar.c"
}

static void
menu_bar_set_accel_group (MenuBar* self,
                          GtkAccelGroup* value)
{
	GtkAccelGroup* old_value;
#line 83 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 83 "menubar.vala"
	old_value = menu_bar_get_accel_group (self);
#line 83 "menubar.vala"
	if (old_value != value) {
#line 6065 "menubar.c"
		GtkAccelGroup* _tmp0_;
#line 83 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 83 "menubar.vala"
		_g_object_unref0 (self->priv->_accel_group);
#line 83 "menubar.vala"
		self->priv->_accel_group = _tmp0_;
#line 83 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_ACCEL_GROUP_PROPERTY]);
#line 6075 "menubar.c"
	}
}

MainWindow*
menu_bar_get_main_window (MenuBar* self)
{
	MainWindow* result;
	MainWindow* _tmp0_;
#line 84 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "menubar.vala"
	_tmp0_ = self->priv->_main_window;
#line 84 "menubar.vala"
	result = _tmp0_;
#line 84 "menubar.vala"
	return result;
#line 6092 "menubar.c"
}

static void
menu_bar_set_main_window (MenuBar* self,
                          MainWindow* value)
{
	MainWindow* old_value;
#line 84 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 84 "menubar.vala"
	old_value = menu_bar_get_main_window (self);
#line 84 "menubar.vala"
	if (old_value != value) {
#line 6106 "menubar.c"
		MainWindow* _tmp0_;
#line 84 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 84 "menubar.vala"
		_g_object_unref0 (self->priv->_main_window);
#line 84 "menubar.vala"
		self->priv->_main_window = _tmp0_;
#line 84 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_MAIN_WINDOW_PROPERTY]);
#line 6116 "menubar.c"
	}
}

static gboolean
_menu_bar_update_clock_gsource_func (gpointer self)
{
	gboolean result;
	result = menu_bar_update_clock ((MenuBar*) self);
#line 163 "menubar.vala"
	return result;
#line 6127 "menubar.c"
}

static void
_menu_bar_on_power_device_added_upower_daemon_device_added (UPowerDaemon* _sender,
                                                            const char* device,
                                                            gpointer self)
{
#line 188 "menubar.vala"
	menu_bar_on_power_device_added ((MenuBar*) self, device);
#line 6137 "menubar.c"
}

static void
_menu_bar_on_power_device_removed_upower_daemon_device_removed (UPowerDaemon* _sender,
                                                                const char* device,
                                                                gpointer self)
{
#line 189 "menubar.vala"
	menu_bar_on_power_device_removed ((MenuBar*) self, device);
#line 6147 "menubar.c"
}

static void
_menu_bar_on_power_device_changed_upower_daemon_device_changed (UPowerDaemon* _sender,
                                                                const char* device,
                                                                gpointer self)
{
#line 190 "menubar.vala"
	menu_bar_on_power_device_changed ((MenuBar*) self, device);
#line 6157 "menubar.c"
}

static void
_menu_bar_on_changed_upower_daemon_changed (UPowerDaemon* _sender,
                                            gpointer self)
{
#line 191 "menubar.vala"
	menu_bar_on_changed ((MenuBar*) self);
#line 6166 "menubar.c"
}

static void
_menu_bar_on_sleeping_upower_daemon_sleeping (UPowerDaemon* _sender,
                                              gpointer self)
{
#line 192 "menubar.vala"
	menu_bar_on_sleeping ((MenuBar*) self);
#line 6175 "menubar.c"
}

static void
_menu_bar_on_resuming_upower_daemon_resuming (UPowerDaemon* _sender,
                                              gpointer self)
{
#line 193 "menubar.vala"
	menu_bar_on_resuming ((MenuBar*) self);
#line 6184 "menubar.c"
}

static gboolean
_menu_bar_query_upower_daemon_gsource_func (gpointer self)
{
	gboolean result;
	result = menu_bar_query_upower_daemon ((MenuBar*) self);
#line 195 "menubar.vala"
	return result;
#line 6194 "menubar.c"
}

static void
_menu_bar_cleanup_slick_greeter_starting_session (SlickGreeter* _sender,
                                                  gpointer self)
{
#line 240 "menubar.vala"
	menu_bar_cleanup ((MenuBar*) self);
#line 6203 "menubar.c"
}

static GObject *
menu_bar_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MenuBar * self;
	GtkSettings* _tmp0_;
	gchar* _tmp1_ = NULL;
	SlickGreeter* _tmp79_;
	GError* _inner_error0_ = NULL;
#line 138 "menubar.vala"
	parent_class = G_OBJECT_CLASS (menu_bar_parent_class);
#line 138 "menubar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 138 "menubar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU_BAR, MenuBar);
#line 140 "menubar.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 140 "menubar.vala"
	g_object_get ((GObject*) _tmp0_, "gtk-theme-name", &_tmp1_, NULL);
#line 140 "menubar.vala"
	_g_free0 (self->priv->default_theme_name);
#line 140 "menubar.vala"
	self->priv->default_theme_name = _tmp1_;
#line 142 "menubar.vala"
	gtk_menu_bar_set_pack_direction ((GtkMenuBar*) self, GTK_PACK_DIRECTION_RTL);
#line 144 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_QUIT)) {
#line 6236 "menubar.c"
		GtkMenuItem* session_menu = NULL;
		GtkMenuItem* _tmp2_;
		GtkMenuItem* _tmp3_;
#line 146 "menubar.vala"
		_tmp2_ = menu_bar_make_session_item (self);
#line 146 "menubar.vala"
		session_menu = _tmp2_;
#line 147 "menubar.vala"
		_tmp3_ = session_menu;
#line 147 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp3_);
#line 144 "menubar.vala"
		_g_object_unref0 (session_menu);
#line 6250 "menubar.c"
	}
#line 150 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_CLOCK)) {
#line 6254 "menubar.c"
		GtkLabel* _tmp4_;
		GdkRGBA clock_fg = {0};
		GtkLabel* _tmp5_;
		GtkStyleContext* _tmp6_;
		GdkRGBA _tmp7_ = {0};
		GtkLabel* _tmp8_;
		GdkRGBA _tmp9_;
		GtkLabel* _tmp10_;
		GtkMenuItem* item = NULL;
		GtkMenuItem* _tmp11_;
		GtkMenuItem* _tmp12_;
		GtkLabel* _tmp13_;
		GtkMenuItem* _tmp14_;
		GtkMenuItem* _tmp15_;
		GtkMenuItem* _tmp16_;
		gchar* _tmp17_;
#line 152 "menubar.vala"
		_tmp4_ = (GtkLabel*) gtk_label_new ("");
#line 152 "menubar.vala"
		g_object_ref_sink (_tmp4_);
#line 152 "menubar.vala"
		_g_object_unref0 (self->priv->clock_label);
#line 152 "menubar.vala"
		self->priv->clock_label = _tmp4_;
#line 153 "menubar.vala"
		_tmp5_ = self->priv->clock_label;
#line 153 "menubar.vala"
		_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
#line 153 "menubar.vala"
		gtk_style_context_get_color (_tmp6_, GTK_STATE_FLAG_NORMAL, &_tmp7_);
#line 153 "menubar.vala"
		clock_fg = _tmp7_;
#line 154 "menubar.vala"
		_tmp8_ = self->priv->clock_label;
#line 154 "menubar.vala"
		_tmp9_ = clock_fg;
#line 154 "menubar.vala"
		gtk_widget_override_color ((GtkWidget*) _tmp8_, GTK_STATE_FLAG_INSENSITIVE, &_tmp9_);
#line 155 "menubar.vala"
		_tmp10_ = self->priv->clock_label;
#line 155 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp10_);
#line 156 "menubar.vala"
		_tmp11_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 156 "menubar.vala"
		g_object_ref_sink (_tmp11_);
#line 156 "menubar.vala"
		item = _tmp11_;
#line 157 "menubar.vala"
		_tmp12_ = item;
#line 157 "menubar.vala"
		_tmp13_ = self->priv->clock_label;
#line 157 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 158 "menubar.vala"
		_tmp14_ = item;
#line 158 "menubar.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
#line 159 "menubar.vala"
		_tmp15_ = item;
#line 159 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp15_);
#line 160 "menubar.vala"
		_tmp16_ = item;
#line 160 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp16_);
#line 161 "menubar.vala"
		_tmp17_ = ug_settings_get_string (UG_SETTINGS_KEY_CLOCK_FORMAT);
#line 161 "menubar.vala"
		_g_free0 (self->priv->clock_format);
#line 161 "menubar.vala"
		self->priv->clock_format = _tmp17_;
#line 162 "menubar.vala"
		menu_bar_update_clock (self);
#line 163 "menubar.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, _menu_bar_update_clock_gsource_func, g_object_ref (self), g_object_unref);
#line 150 "menubar.vala"
		_g_object_unref0 (item);
#line 6333 "menubar.c"
	}
#line 166 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_POWER)) {
#line 6337 "menubar.c"
		GtkMenuItem* _tmp18_;
		GtkBox* hbox = NULL;
		GtkBox* _tmp19_;
		GtkBox* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GtkImage* _tmp23_;
		GtkImage* _tmp24_;
		GtkBox* _tmp25_;
		GtkImage* _tmp26_;
		GtkBox* _tmp27_;
		GtkLabel* _tmp28_;
		GtkLabel* _tmp29_;
		GdkRGBA power_fg = {0};
		GtkLabel* _tmp30_;
		GtkStyleContext* _tmp31_;
		GdkRGBA _tmp32_ = {0};
		GtkLabel* _tmp33_;
		GdkRGBA _tmp34_;
		GtkLabel* _tmp35_;
		GtkBox* _tmp36_;
		GtkLabel* _tmp37_;
		GtkMenuItem* _tmp38_;
		GtkBox* _tmp39_;
		GtkMenuItem* _tmp40_;
		GtkMenuItem* _tmp41_;
#line 168 "menubar.vala"
		_tmp18_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 168 "menubar.vala"
		g_object_ref_sink (_tmp18_);
#line 168 "menubar.vala"
		_g_object_unref0 (self->priv->power_menu_item);
#line 168 "menubar.vala"
		self->priv->power_menu_item = _tmp18_;
#line 169 "menubar.vala"
		_tmp19_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 169 "menubar.vala"
		g_object_ref_sink (_tmp19_);
#line 169 "menubar.vala"
		hbox = _tmp19_;
#line 170 "menubar.vala"
		_tmp20_ = hbox;
#line 170 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp20_);
#line 171 "menubar.vala"
		_tmp21_ = g_build_filename (PKGDATADIR, "battery.svg", NULL);
#line 171 "menubar.vala"
		_tmp22_ = _tmp21_;
#line 171 "menubar.vala"
		_tmp23_ = (GtkImage*) gtk_image_new_from_file (_tmp22_);
#line 171 "menubar.vala"
		g_object_ref_sink (_tmp23_);
#line 171 "menubar.vala"
		_g_object_unref0 (self->priv->power_icon);
#line 171 "menubar.vala"
		self->priv->power_icon = _tmp23_;
#line 171 "menubar.vala"
		_g_free0 (_tmp22_);
#line 172 "menubar.vala"
		_tmp24_ = self->priv->power_icon;
#line 172 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp24_);
#line 173 "menubar.vala"
		_tmp25_ = hbox;
#line 173 "menubar.vala"
		_tmp26_ = self->priv->power_icon;
#line 173 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 174 "menubar.vala"
		_tmp27_ = hbox;
#line 174 "menubar.vala"
		gtk_box_set_spacing (_tmp27_, 6);
#line 175 "menubar.vala"
		_tmp28_ = (GtkLabel*) gtk_label_new ("");
#line 175 "menubar.vala"
		g_object_ref_sink (_tmp28_);
#line 175 "menubar.vala"
		_g_object_unref0 (self->priv->power_label);
#line 175 "menubar.vala"
		self->priv->power_label = _tmp28_;
#line 176 "menubar.vala"
		_tmp29_ = self->priv->power_label;
#line 176 "menubar.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp29_, FALSE);
#line 177 "menubar.vala"
		_tmp30_ = self->priv->power_label;
#line 177 "menubar.vala"
		_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
#line 177 "menubar.vala"
		gtk_style_context_get_color (_tmp31_, GTK_STATE_FLAG_NORMAL, &_tmp32_);
#line 177 "menubar.vala"
		power_fg = _tmp32_;
#line 178 "menubar.vala"
		_tmp33_ = self->priv->power_label;
#line 178 "menubar.vala"
		_tmp34_ = power_fg;
#line 178 "menubar.vala"
		gtk_widget_override_color ((GtkWidget*) _tmp33_, GTK_STATE_FLAG_INSENSITIVE, &_tmp34_);
#line 179 "menubar.vala"
		_tmp35_ = self->priv->power_label;
#line 179 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp35_);
#line 180 "menubar.vala"
		_tmp36_ = hbox;
#line 180 "menubar.vala"
		_tmp37_ = self->priv->power_label;
#line 180 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 181 "menubar.vala"
		_tmp38_ = self->priv->power_menu_item;
#line 181 "menubar.vala"
		_tmp39_ = hbox;
#line 181 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 182 "menubar.vala"
		_tmp40_ = self->priv->power_menu_item;
#line 182 "menubar.vala"
		gtk_widget_hide ((GtkWidget*) _tmp40_);
#line 183 "menubar.vala"
		_tmp41_ = self->priv->power_menu_item;
#line 183 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp41_);
#line 6460 "menubar.c"
		{
			UPowerDaemon* _tmp42_ = NULL;
			UPowerDaemon* _tmp43_;
			UPowerDaemon* _tmp44_;
			UPowerDaemon* _tmp45_;
			UPowerDaemon* _tmp46_;
			UPowerDaemon* _tmp47_;
			UPowerDaemon* _tmp48_;
			UPowerDaemon* _tmp49_;
			UPowerDaemon* _tmp50_;
#line 187 "menubar.vala"
			_tmp43_ = (UPowerDaemon*) g_initable_new (UPOWER_TYPE_DAEMON_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.UPower", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/UPower", "g-interface-name", "org.freedesktop.UPower", NULL);
#line 187 "menubar.vala"
			_tmp42_ = (UPowerDaemon*) _tmp43_;
#line 187 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 187 "menubar.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 6479 "menubar.c"
					goto __catch0_g_io_error;
				}
#line 187 "menubar.vala"
				_g_object_unref0 (hbox);
#line 187 "menubar.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 187 "menubar.vala"
				g_clear_error (&_inner_error0_);
#line 6488 "menubar.c"
			}
#line 187 "menubar.vala"
			_tmp44_ = _tmp42_;
#line 187 "menubar.vala"
			_tmp42_ = NULL;
#line 187 "menubar.vala"
			_g_object_unref0 (self->priv->upowerd);
#line 187 "menubar.vala"
			self->priv->upowerd = _tmp44_;
#line 188 "menubar.vala"
			_tmp45_ = self->priv->upowerd;
#line 188 "menubar.vala"
			g_signal_connect_object (_tmp45_, "device-added", (GCallback) _menu_bar_on_power_device_added_upower_daemon_device_added, self, 0);
#line 189 "menubar.vala"
			_tmp46_ = self->priv->upowerd;
#line 189 "menubar.vala"
			g_signal_connect_object (_tmp46_, "device-removed", (GCallback) _menu_bar_on_power_device_removed_upower_daemon_device_removed, self, 0);
#line 190 "menubar.vala"
			_tmp47_ = self->priv->upowerd;
#line 190 "menubar.vala"
			g_signal_connect_object (_tmp47_, "device-changed", (GCallback) _menu_bar_on_power_device_changed_upower_daemon_device_changed, self, 0);
#line 191 "menubar.vala"
			_tmp48_ = self->priv->upowerd;
#line 191 "menubar.vala"
			g_signal_connect_object (_tmp48_, "changed", (GCallback) _menu_bar_on_changed_upower_daemon_changed, self, 0);
#line 192 "menubar.vala"
			_tmp49_ = self->priv->upowerd;
#line 192 "menubar.vala"
			g_signal_connect_object (_tmp49_, "sleeping", (GCallback) _menu_bar_on_sleeping_upower_daemon_sleeping, self, 0);
#line 193 "menubar.vala"
			_tmp50_ = self->priv->upowerd;
#line 193 "menubar.vala"
			g_signal_connect_object (_tmp50_, "resuming", (GCallback) _menu_bar_on_resuming_upower_daemon_resuming, self, 0);
#line 194 "menubar.vala"
			menu_bar_query_upower_daemon (self);
#line 195 "menubar.vala"
			g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 60000, _menu_bar_query_upower_daemon_gsource_func, g_object_ref (self), g_object_unref);
#line 185 "menubar.vala"
			_g_object_unref0 (_tmp42_);
#line 6528 "menubar.c"
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp51_;
			const gchar* _tmp52_;
#line 185 "menubar.vala"
			e = _inner_error0_;
#line 185 "menubar.vala"
			_inner_error0_ = NULL;
#line 198 "menubar.vala"
			_tmp51_ = e;
#line 198 "menubar.vala"
			_tmp52_ = _tmp51_->message;
#line 198 "menubar.vala"
			g_warning ("menubar.vala:198: Could not connect to Upower: %s", _tmp52_);
#line 185 "menubar.vala"
			_g_error_free0 (e);
#line 6548 "menubar.c"
		}
		__finally0:
#line 185 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "menubar.vala"
			_g_object_unref0 (hbox);
#line 185 "menubar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 185 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 6559 "menubar.c"
		}
#line 166 "menubar.vala"
		_g_object_unref0 (hbox);
#line 6563 "menubar.c"
	}
#line 202 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_KEYBOARD)) {
#line 6567 "menubar.c"
		GtkMenuItem* keyboard_menu = NULL;
		GtkMenuItem* _tmp53_;
		GtkMenuItem* _tmp54_;
#line 204 "menubar.vala"
		_tmp53_ = menu_bar_make_keyboard_item (self);
#line 204 "menubar.vala"
		keyboard_menu = _tmp53_;
#line 205 "menubar.vala"
		_tmp54_ = keyboard_menu;
#line 205 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp54_);
#line 202 "menubar.vala"
		_g_object_unref0 (keyboard_menu);
#line 6581 "menubar.c"
	}
#line 208 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_A11Y)) {
#line 6585 "menubar.c"
		GtkMenuItem* a11y_item = NULL;
		GtkMenuItem* _tmp55_;
		GtkMenuItem* _tmp56_;
#line 210 "menubar.vala"
		_tmp55_ = menu_bar_make_a11y_item (self);
#line 210 "menubar.vala"
		a11y_item = _tmp55_;
#line 211 "menubar.vala"
		_tmp56_ = a11y_item;
#line 211 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp56_);
#line 208 "menubar.vala"
		_g_object_unref0 (a11y_item);
#line 6599 "menubar.c"
	}
#line 214 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_HOSTNAME)) {
#line 6603 "menubar.c"
		GtkLabel* label = NULL;
		struct utsname _tmp57_ = {0};
		const gchar* _tmp58_;
		GtkLabel* _tmp59_;
		GdkRGBA hostname_fg = {0};
		GtkLabel* _tmp60_;
		GtkStyleContext* _tmp61_;
		GdkRGBA _tmp62_ = {0};
		GtkLabel* _tmp63_;
		GdkRGBA _tmp64_;
		GtkLabel* _tmp65_;
		GtkMenuItem* hostname_item = NULL;
		GtkMenuItem* _tmp66_;
		GtkMenuItem* _tmp67_;
		GtkLabel* _tmp68_;
		GtkMenuItem* _tmp69_;
		GtkMenuItem* _tmp70_;
		GtkMenuItem* _tmp71_;
		GtkMenuItem* _tmp72_;
#line 216 "menubar.vala"
		uname (&_tmp57_);
#line 216 "menubar.vala"
		_tmp58_ = _tmp57_.nodename;
#line 216 "menubar.vala"
		_tmp59_ = (GtkLabel*) gtk_label_new (_tmp58_);
#line 216 "menubar.vala"
		g_object_ref_sink (_tmp59_);
#line 216 "menubar.vala"
		label = _tmp59_;
#line 217 "menubar.vala"
		_tmp60_ = label;
#line 217 "menubar.vala"
		_tmp61_ = gtk_widget_get_style_context ((GtkWidget*) _tmp60_);
#line 217 "menubar.vala"
		gtk_style_context_get_color (_tmp61_, GTK_STATE_FLAG_NORMAL, &_tmp62_);
#line 217 "menubar.vala"
		hostname_fg = _tmp62_;
#line 218 "menubar.vala"
		_tmp63_ = label;
#line 218 "menubar.vala"
		_tmp64_ = hostname_fg;
#line 218 "menubar.vala"
		gtk_widget_override_color ((GtkWidget*) _tmp63_, GTK_STATE_FLAG_INSENSITIVE, &_tmp64_);
#line 219 "menubar.vala"
		_tmp65_ = label;
#line 219 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp65_);
#line 220 "menubar.vala"
		_tmp66_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 220 "menubar.vala"
		g_object_ref_sink (_tmp66_);
#line 220 "menubar.vala"
		hostname_item = _tmp66_;
#line 221 "menubar.vala"
		_tmp67_ = hostname_item;
#line 221 "menubar.vala"
		_tmp68_ = label;
#line 221 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
#line 222 "menubar.vala"
		_tmp69_ = hostname_item;
#line 222 "menubar.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp69_, FALSE);
#line 223 "menubar.vala"
		_tmp70_ = hostname_item;
#line 223 "menubar.vala"
		gtk_menu_item_set_right_justified (_tmp70_, TRUE);
#line 224 "menubar.vala"
		_tmp71_ = hostname_item;
#line 224 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp71_);
#line 225 "menubar.vala"
		_tmp72_ = hostname_item;
#line 225 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp72_);
#line 214 "menubar.vala"
		_g_object_unref0 (hostname_item);
#line 214 "menubar.vala"
		_g_object_unref0 (label);
#line 6683 "menubar.c"
	}
	{
		GtkCssProvider* style = NULL;
		GtkCssProvider* _tmp73_;
		GtkCssProvider* _tmp74_;
		GtkStyleContext* _tmp75_;
		GtkCssProvider* _tmp76_;
#line 231 "menubar.vala"
		_tmp73_ = gtk_css_provider_new ();
#line 231 "menubar.vala"
		style = _tmp73_;
#line 232 "menubar.vala"
		_tmp74_ = style;
#line 232 "menubar.vala"
		gtk_css_provider_load_from_data (_tmp74_, "* {-GtkWidget-window-dragging: false;}", (gssize) -1, &_inner_error0_);
#line 232 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 232 "menubar.vala"
			_g_object_unref0 (style);
#line 6703 "menubar.c"
			goto __catch1_g_error;
		}
#line 233 "menubar.vala"
		_tmp75_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 233 "menubar.vala"
		_tmp76_ = style;
#line 233 "menubar.vala"
		gtk_style_context_add_provider (_tmp75_, (GtkStyleProvider*) _tmp76_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 229 "menubar.vala"
		_g_object_unref0 (style);
#line 6714 "menubar.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp77_;
		const gchar* _tmp78_;
#line 229 "menubar.vala"
		e = _inner_error0_;
#line 229 "menubar.vala"
		_inner_error0_ = NULL;
#line 237 "menubar.vala"
		_tmp77_ = e;
#line 237 "menubar.vala"
		_tmp78_ = _tmp77_->message;
#line 237 "menubar.vala"
		g_debug ("menubar.vala:237: Internal error loading menubar style: %s", _tmp78_);
#line 229 "menubar.vala"
		_g_error_free0 (e);
#line 6734 "menubar.c"
	}
	__finally1:
#line 229 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 229 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 6743 "menubar.c"
	}
#line 240 "menubar.vala"
	_tmp79_ = slick_greeter_singleton;
#line 240 "menubar.vala"
	g_signal_connect_object (_tmp79_, "starting-session", (GCallback) _menu_bar_cleanup_slick_greeter_starting_session, self, 0);
#line 138 "menubar.vala"
	return obj;
#line 6751 "menubar.c"
}

static void
menu_bar_class_init (MenuBarClass * klass,
                     gpointer klass_data)
{
#line 78 "menubar.vala"
	menu_bar_parent_class = g_type_class_peek_parent (klass);
#line 78 "menubar.vala"
	g_type_class_adjust_private_offset (klass, &MenuBar_private_offset);
#line 78 "menubar.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) menu_bar_real_draw;
#line 78 "menubar.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) menu_bar_real_get_preferred_height;
#line 78 "menubar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_menu_bar_get_property;
#line 78 "menubar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_menu_bar_set_property;
#line 78 "menubar.vala"
	G_OBJECT_CLASS (klass)->constructor = menu_bar_constructor;
#line 78 "menubar.vala"
	G_OBJECT_CLASS (klass)->finalize = menu_bar_finalize;
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_BACKGROUND_PROPERTY, menu_bar_properties[MENU_BAR_BACKGROUND_PROPERTY] = g_param_spec_object ("background", "background", "background", TYPE_BACKGROUND, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_HIGH_CONTRAST_PROPERTY, menu_bar_properties[MENU_BAR_HIGH_CONTRAST_PROPERTY] = g_param_spec_boolean ("high-contrast", "high-contrast", "high-contrast", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_KEYBOARD_WINDOW_PROPERTY, menu_bar_properties[MENU_BAR_KEYBOARD_WINDOW_PROPERTY] = g_param_spec_object ("keyboard-window", "keyboard-window", "keyboard-window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_ACCEL_GROUP_PROPERTY, menu_bar_properties[MENU_BAR_ACCEL_GROUP_PROPERTY] = g_param_spec_object ("accel-group", "accel-group", "accel-group", gtk_accel_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_MAIN_WINDOW_PROPERTY, menu_bar_properties[MENU_BAR_MAIN_WINDOW_PROPERTY] = g_param_spec_object ("main-window", "main-window", "main-window", TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6784 "menubar.c"
}

static void
menu_bar_instance_init (MenuBar * self,
                        gpointer klass)
{
#line 78 "menubar.vala"
	self->priv = menu_bar_get_instance_private (self);
#line 80 "menubar.vala"
	self->priv->_background = NULL;
#line 81 "menubar.vala"
	self->priv->_high_contrast = FALSE;
#line 82 "menubar.vala"
	self->priv->_keyboard_window = NULL;
#line 84 "menubar.vala"
	self->priv->_main_window = NULL;
#line 128 "menubar.vala"
	self->priv->keyboard_pid = (GPid) 0;
#line 129 "menubar.vala"
	self->priv->reader_pid = (GPid) 0;
#line 6805 "menubar.c"
}

static void
menu_bar_finalize (GObject * obj)
{
	MenuBar * self;
#line 78 "menubar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU_BAR, MenuBar);
#line 80 "menubar.vala"
	_g_object_unref0 (self->priv->_background);
#line 82 "menubar.vala"
	_g_object_unref0 (self->priv->_keyboard_window);
#line 83 "menubar.vala"
	_g_object_unref0 (self->priv->_accel_group);
#line 84 "menubar.vala"
	_g_object_unref0 (self->priv->_main_window);
#line 125 "menubar.vala"
	_g_free0 (self->priv->default_theme_name);
#line 126 "menubar.vala"
	_g_free0 (self->priv->clock_format);
#line 127 "menubar.vala"
	_g_object_unref0 (self->priv->high_contrast_item);
#line 130 "menubar.vala"
	_g_object_unref0 (self->priv->onscreen_keyboard_item);
#line 131 "menubar.vala"
	_g_object_unref0 (self->priv->clock_label);
#line 132 "menubar.vala"
	_g_object_unref0 (self->priv->upowerd);
#line 133 "menubar.vala"
	_g_object_unref0 (self->priv->power_menu_item);
#line 134 "menubar.vala"
	_g_object_unref0 (self->priv->power_label);
#line 135 "menubar.vala"
	_g_object_unref0 (self->priv->power_icon);
#line 78 "menubar.vala"
	G_OBJECT_CLASS (menu_bar_parent_class)->finalize (obj);
#line 6842 "menubar.c"
}

static GType
menu_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MenuBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) menu_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MenuBar), 0, (GInstanceInitFunc) menu_bar_instance_init, NULL };
	GType menu_bar_type_id;
	menu_bar_type_id = g_type_register_static (gtk_menu_bar_get_type (), "MenuBar", &g_define_type_info, 0);
	MenuBar_private_offset = g_type_add_instance_private (menu_bar_type_id, sizeof (MenuBarPrivate));
	return menu_bar_type_id;
}

GType
menu_bar_get_type (void)
{
	static volatile gsize menu_bar_type_id__once = 0;
	if (g_once_init_enter (&menu_bar_type_id__once)) {
		GType menu_bar_type_id;
		menu_bar_type_id = menu_bar_get_type_once ();
		g_once_init_leave (&menu_bar_type_id__once, menu_bar_type_id);
	}
	return menu_bar_type_id__once;
}

static void
_vala_menu_bar_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	MenuBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_BAR, MenuBar);
#line 78 "menubar.vala"
	switch (property_id) {
#line 78 "menubar.vala"
		case MENU_BAR_BACKGROUND_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_object (value, menu_bar_get_background (self));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_HIGH_CONTRAST_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_boolean (value, menu_bar_get_high_contrast (self));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_KEYBOARD_WINDOW_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_object (value, menu_bar_get_keyboard_window (self));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_ACCEL_GROUP_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_object (value, menu_bar_get_accel_group (self));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_MAIN_WINDOW_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_object (value, menu_bar_get_main_window (self));
#line 78 "menubar.vala"
		break;
#line 6907 "menubar.c"
		default:
#line 78 "menubar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 78 "menubar.vala"
		break;
#line 6913 "menubar.c"
	}
}

static void
_vala_menu_bar_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	MenuBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_BAR, MenuBar);
#line 78 "menubar.vala"
	switch (property_id) {
#line 78 "menubar.vala"
		case MENU_BAR_BACKGROUND_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_background (self, g_value_get_object (value));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_HIGH_CONTRAST_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_high_contrast (self, g_value_get_boolean (value));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_KEYBOARD_WINDOW_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_keyboard_window (self, g_value_get_object (value));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_ACCEL_GROUP_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_accel_group (self, g_value_get_object (value));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_MAIN_WINDOW_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_main_window (self, g_value_get_object (value));
#line 78 "menubar.vala"
		break;
#line 6957 "menubar.c"
		default:
#line 78 "menubar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 78 "menubar.vala"
		break;
#line 6963 "menubar.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

